/echo -aB ## Logging/Alert macros loaded.
/echo -aB ## Type "/LogHelp" for more info

; requires ~/tfstuff/log/ to exist
;
; [[ GM: Name ]] text
; [[ GM: Name emote ]]

/set beep_class_en=0
/set beep_party_en=0
/set beep_tell_en=0

/set log_class_en=0
/set lfn_class=~/tfstuff/log/class.log
/set log_tell_en=0
/set lfn_tell=~/tfstuff/log/tell.log
/set log_party_en=0
/set lfn_party=~/tfstuff/log/party.log

/def -i LogHelp = \
	/echo -aB * Logging Options %;\
	/echo -aB * %;\
	/echo -aB * /LogTypes            Lists valid types %;\
	/echo -aB * /LogStatus           Display logging status %;\
	/echo -aB * /LogOn <type>        Enable logging of <type> %;\
	/echo -aB * /LogOff <type>       Disable logging of <type> %;\
	/echo -aB * /LogCheck <type>     View log of <type> %;\
	/echo -aB * /LogClose            Close all open log files %;\
	/echo -aB * /BeepOn <type>       Enable audio alert for <type> %;\
	/echo -aB * /BeepOff <type>      Disable audio alert for <type> %;\
	/echo -aB * /BeepStatus          Display audio alert status %;\
	/echo -aB * %;\
	/echo -aB * /LogUnload           Unload logging macros

/def -i LogOn = \
	/if ({1} =~ "class") \
		/set log_class_en=1 %;\
		/echo -aB * Class logging enabled. %;\
	/elseif ({1} =~ "party") \
		/set log_party_en=1 %;\
		/echo -aB * Party logging enabled. %;\
	/elseif ({1} =~ "tell") \
		/set log_tell_en=1 %;\
		/echo -aB * Tell logging enabled. %;\
	/else \
		/LogTypes %;\
	/endif

/def -i LogOff = \
	/if ({1} =~ "class") \
		/set log_class_en=0 %;\
		/echo -aB * Class logging disabled. %;\
	/elseif ({1} =~ "party") \
		/set log_party_en=0 %;\
		/echo -aB * Party logging disabled. %;\
	/elseif ({1} =~ "tell") \
		/set log_tell_en=0 %;\
		/echo -aB * Tell logging disabled. %;\
	/else \
		/LogTypes %;\
	/endif

/def -i LogStatus = \
  /echo -aB * Class logging:  %log_class_en %;\
  /echo -aB * Party logging:  %log_party_en %;\
  /echo -aB * Tell logging:   %log_tell_en

/def -i LogTypes = \
	/echo -aB * Valid options:  class party tell %;\

/def -i BeepOn = \
	/if ({1} =~ "class") \
		/set beep_class_en=1 %;\
		/echo -aB * Class alert enabled. %;\
	/elseif ({1} =~ "party") \
		/set beep_party_en=1 %;\
		/echo -aB * Party alert enabled. %;\
	/elseif ({1} =~ "tell") \
		/set beep_tell_en=1 %;\
		/echo -aB * Tell alert enabled. %;\
	/else \
		/LogTypes %;\
	/endif

/def -i BeepOff = \
	/if ({1} =~ "class") \
		/set beep_class_en=0 %;\
		/echo -aB * Class alert disabled. %;\
	/elseif ({1} =~ "party") \
		/set beep_party_en=0 %;\
		/echo -aB * Party alert disabled. %;\
	/elseif ({1} =~ "tell") \
		/set beep_tell_en=0 %;\
		/echo -aB * Tell alert disabled. %;\
	/else \
		/LogTypes %;\
	/endif

/def -i BeepStatus = \
  /echo -aB * Class alert:  %beep_class_en %;\
  /echo -aB * Party alert:  %beep_party_en %;\
  /echo -aB * Tell alert:   %beep_tell_en

/def -i LogCheck = \
	/if ({1} =~ "class") \
		/quote -0 /echo '%lfn_class %;\
	/elseif ({1} =~ "party") \
		/quote -0 /echo '%lfn_party %;\
	/elseif ({1} =~ "tell") \
		/quote -0 /echo '%lfn_tell %;\
	/else \
		/LogTypes %;\
	/endif

/def LogClose = \
	/if (lfp_class > 0) \
		/let ret=$[tfclose({lfp_class})] %;/set lfp_class=0 %;\
	/endif %;\
	/if (lfp_party > 0) \
		/let ret=$[tfclose({lfp_party})] %;/set lfp_party=0 %;\
	/endif %;\
	/if (lfp_tell > 0) \
		/let ret=$[tfclose({lfp_tell})] %;/set lfp_tell=0 %;\
	/endif %;\
	/echo -aB * Open log files closed.

;
; Class logging
;
/def -iFp9999 -mregexp -t'^[> ]*\*-\*.+\*-\*' Log_Class = \
	/if (beep_class_en == 1) /beep %;/endif %;\
	/if (log_class_en != 1) /return %;/endif %;\
	/let logtime=$[ftime("[%b %d %Y %H:%M:%S]", time())] %;\
	/if (lfp_class <= 0) \
		/set lfp_class=$[tfopen({lfn_class},"a")] %;\
		/eval /let ret=$$[tfwrite({lfp_class}, "%logtime ***NEW SESSION STARTED***")] %;\
	/endif %;\
	/eval /let ret=$$[tfwrite({lfp_class}, "%logtime %*")]

;
; Party logging
;
/def -iFp9999 -mregexp -t'^[> ]*<< [A-Za-z]+ >>' Log_Party = \
	/if (beep_party_en == 1) /beep %;/endif %;\
	/if (log_party_en != 1) /return %;/endif %;\
	/let logtime=$[ftime("[%b %d %Y %H:%M:%S]", time())] %;\
	/if (lfp_party <= 0) \
		/set lfp_party=$[tfopen({lfn_party},"a")] %;\
		/eval /let ret=$$[tfwrite({lfp_party}, "%logtime ***NEW SESSION STARTED***")] %;\
	/endif %;\
	/eval /let ret=$$[tfwrite({lfp_party}, "%logtime %*")]

;
; Tell logging
;
/def -i Log_Tell = \
	/if (beep_tell_en == 1) /beep %;/endif %;\
	/if (log_tell_en != 1) /return %;/endif %;\
	/let logtime=$[ftime("[%b %d %Y %H:%M:%S]", time())] %;\
	/if (lfp_tell <= 0) \
		/set lfp_tell=$[tfopen({lfn_tell},"a")] %;\
		/eval /let ret=$$[tfwrite({lfp_tell}, "%logtime ***NEW SESSION STARTED***")] %;\
	/endif %;\
	/eval /let ret=$$[tfwrite({lfp_tell}, "%logtime %*")]

/def -iFp9999 -mregexp -t'^[> ]*You tell' Log_Tell1 = /Log_Tell %*
/def -iFp9999 -mregexp -t'^[> ]*You reply to' Log_Tell2 = /Log_Tell %*
/def -iFp9999 -mregexp -t'^[> ]*[A-Za-z]+ tells you:' Log_Tell3 = /Log_Tell %*
/def -iFp9999 -mregexp -t'^[> ]*[A-Za-z]+ replies:' Log_Tell4 = /Log_Tell %*

/def LogUnload = \
	/LogClose %;\
	/undef BeepOn %;\
	/undef BeepOff %;\
	/undef BeepStatus %;\
	/unset beep_class_en %;\
	/unset beep_party_en %;\
	/unset beep_tell_en %;\
	/undef LogHelp %;\
	/undef LogOn %;\
	/undef LogOff %;\
	/undef LogStatus %;\
	/undef LogCheck %;\
	/undef LogClose %;\
	/undef Log_Class %;\
	/undef Log_Party %;\
	/undef Log_Tell %;\
	/undef Log_Tell1 %;\
	/undef Log_Tell2 %;\
	/undef Log_Tell3 %;\
	/undef Log_Tell4 %;\
	/unset lfn_class %;\
	/unset log_class_en %;\
	/unset lfp_class %;\
	/unset lfn_party %;\
	/unset log_party_en %;\
	/unset lfp_party %;\
	/unset lfn_tell %;\
	/unset log_tell_en %;\
	/unset lfp_tell %;\
	/undef LogUnload
