
;
; Bs.tf
;
; In/out triggers for Overdrive thieves.
;
; Requires util.tf and prompt.tf
;
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: util.tf v0.8 required for bs.tf %;\
 /endif

/if /test prompt_tf < 13 %; /then \
    /echo % WARNING: prompt.tf v1.1 required for bs.tf %;\
 /endif

/set bs_tf=33
/def -i bsVer = /echo @(#) bs.tf versbsn 3.3 (10/25/96)

/eval /set bs_res=%?

/def -i bsDef = /def -i bs%{*}

/def -i bsActDef = /def -i bsAction%{*}

; Initalize variables.

/bsDef Reset = \
  /set bsState=off %;\
  /set bsGag=off %;\
  /set bsInform=off %;\
  /set bsDelay=0 %;\
  /set bsLock=0 %;\
  /set bsAuto=0 %;\
  /set crabCount=0 %;\
  /set bsDiedFlag=0

/bsReset

; 
; Main 
;
; Updates monster damage/hits/misses, performs in/out if able,
; executes HpHook and SpHook if auto is on.
;

/bsDef Main = \
   /if /test bsInHp %; /then \
       /let bsDmg=$[bsInHp-HP] %;\
       /if /test bsDmg > 0 %; /then \
           /bsecho2 <<< Damage taken: %{bsDmg} >>> %;\
           /set bsMonTotalDmg=$[bsMonTotalDmg+bsDmg] %;\
           /set bsMonHits=$[(bsMonHits + 1)] %;\
        /endif %;\
       /set bsInHp= %;\
    /endif %;\
   /if /test bsDiedFlag %; /then \
       /bsMonDead %;\
    /endif %;\
   /if /test bsState=~"off" %; /then \
       /pUnHook Main %;\
       /break %;\
    /endif %;\
   /set bsDelayCnt=$[bsDelayCnt + 1] %;\
   /if /test !bsLock & !promptEngaged %; /then \
       /if /test crabCount > 0 %; /then \
           /break %;\
        /endif %;\
       /if /test ((bsDelayCnt + 1) > bsDelay) & ((SP + 10) > bsSpNeeded) \
                 & ((HP + 2) >  bsHpcap) %;/then \
          /send stealth on%;\
       /endif%;\
       /if /test bsState=~"off" %; /then \
           /break %;\
        /endif %;\
       /if /test HP < bsHpcap %; /then \
           /bsAutoHeal Hp %;\
        /elseif /test SP < bsSpNeeded %; /then \
                /bsAutoHeal Sp %;\
        /else \
               /if /test bsDelayCnt > bsDelay %; /then \
                       /bsDo %;\
               /endif %;\
        /endif %;\
    /endif

; Executes heal macro if auto is enabled.

/bsdef AutoHeal = \
   /if /test bsAuto %; /then \
       /bsLock bs.tf/bsAutoHeal: executing %{1}Hook. %;\
       /eval /healDo %{1}Hook bsHealOk bsHealFail %;\
    /endif

; Macros executed on success/fail of heal macro.

/bsDef HealOk = \
   /bsRelease

/bsDef HealFail = \
   /bsStop HP/SP macro failed! %;\
   /bsRelease

; Lock/Release: use to _temporarily_ prevent in/outting

/bsDef Lock = \
   /set bsLock=$[bsLock+1] %;\
   /set bsLock%{bsLock}=%{*} 

/bsDef Release = \
   /if /test bsLock > 0 %; /then \
       /set bsLock=$[bsLock-1] %;\
    /endif
    
/bsDef ShowLock = \
   /if /test bsLock == 0 %; /then \
       /bsecho No locks present. %;\
    /else \
       /for i 1 %{bsLock} /eval /bsecho %%%{bsLock%%{i}} %;\
    /endif 

; Do: actually sends in/out commands to mud

/set doBs=on

/bsDef Do = \
   /if /test bsLock == 0 %; /then \
       /set bsDelay=1 %;\
       /bsaPutQ In %; /bsaPutQ Out %;\
       /bsLock bs.tf/bsDo: executing in/out. %;\
       /bsGoIn backstab %{bsMonster}\10get all from corpse %;\
       /set promptEngaged=0 %;\
    /endif

/bsDef GoIn = \
       /if /test bsMonLoc !~ "" & bsMocLoc !~ mpCurLoc %; /then \
          /mpMark bs %;\
          /goto %{bsMonLoc} %;\
          /let doReturn=1 %;\
       /else \
          /let doReturn=0 %;\
       /endif %;\
       /if /test bsInform =~ "on"%;/then \
         /runbsmacro bsDoInOut %{*}%;\
       /else \
         /bsDoInOut %{*} %;\
       /endif %;\
       /if /test doReturn %; /then \
          /goto mark bs%;\
       /endif %;\

/bsDef DoInOut = \
       /if /test !bsDoMacro %;/then \
         /eval ..\10stealth on\10%{bsIndir}\10%{*}\10%{bsOutdir}\10stealth off\10.. %;\
       /else \
         /eval ..\10stealth on%;/%{bsMacro}%;stealth off%;.. %;\
       /endif %;\

; Action queue system
;
; Execute actions out of queue on .. display.

/bsDef aGetQ = /uGetQ bsActionQ
/bsDef aPutQ = /uPutQ %{1} bsActionQ
/bsDef aClearQ = /set bsActionQ=

/def -i -p100 -ag -mregexp -t'XP : ([0-9]*)  .([0-9]*) left to spend., GD : ([0-9]*)' \
     bsActionTrig = \
   /set bsCurXp=%P1 %; /set bsGold=%P3 %;/set Gold=%P3 %;\
   /let action=$(/bsaGetQ) %;\
   /if /test action=~"" %; /then \
        /echo -aB <<< Damage done: $[(bsCurXp-bsLastXp)/2] >>>%;\
       /echo XP : %P1  (%P2 left to spend), GD : %P3%;\
    /else \
       /eval /bsAction%{action} %;\
    /endif %;\
   /set bsLastXp=%{bsCurXp}

; ActionIn: executed before in/out, initializes vars

/bsActDef In = \
   /set bsDiedXp=0 %;\
   /set bsInHp=%{HP} %;\
   /if /test bsGag=~"on" & bsInOuts!=0 %; /then \
       /uGagOn %;\
    /endif

; ActionOut: executed after in/out, records damage data, checks for monster 
;            death

/bsActDef Out = \
   /uGagOff %;\
   /bsRelease %;\
   /let bsDmg=$[(bsCurXp-bsLastXp)/2] %;\
   /if /test bsgraph_tf > 0 %; /then \
       /eval /set bsDmgAry_%{bsDmg}=$$[(bsDmgAry_%{bsDmg}+1)] %;\
    /endif %;\
   /bsecho2 <<< Damage done: %{bsDmg} >>> %;\
   /if /test bsDmg > 0 %; /then \
       /set bsHits=$[(bsHits+1)] %;\
    /endif %;\
   /set bsInOuts=$[(bsInOuts+1)] %;\
   /set bsTotalDmg=$[(bsTotalDmg+bsDmg)] %;\
   /set bsDelayCnt=0 

; Monster death and experience triggers

/def -i -Fp9999 -mglob -t'*The demon turns to vapor as it dies,*' bsDgDied = /bsDied
/def -i -Fp9999 -mglob -t'*gasps his last breath and falls to the ground!' bsSlarDied = /bsDied
/def -i -Fp9999 -mglob -t'* died!' bsPartyDied = /bsDied

/def -i -Fp9999 -mglob -t'* died.' bsDied = \
    /if /test bsState!~"off" %; /then \
        /set bsDiedFlag=1 %;\
     /endif

/def -i -Fp99 -mregexp -t'You .* ([0-9]*) experience' \
      bsGetXp = \
   /let TempXp=%{P1} %;\
   /if /test bsState!~"off" %; /then \
       /set bsGotXp=$[(TempXp+bsGotXp)] %;\
       /set bsLastXp=$[(bsLastXp+TempXp)] %;\
    /endif

/bsdef MonDead = \
    /if /test bsGotXp!=0 %; /then \
        /set bsDiedXp=%{bsGotXp} %; /set bsGotXp= %;\
        /set bsStopTime=$(/time @) %;\
        /bsStop %;\
        /bsDieHook %;\
        /uaPutQ bsRep %; /send %{uActCmd} %;\
     /endif %;\
    /set bsDiedFlag=0 %;\

;
; In/out control macros
;
; bsStart - Initalize all variables, start in/out
; bsRes   - Resume in/out
; bsStop  - Stop in/out
;

/bsDef Start = \
   /set bsState=on %;\
   /set bsTotalDmg=0 %; /set bsInOuts=0 %; /set bsHits=0 %;\
   /set bsOtherXp=0 %; /set bsDiedXp=0 %; /set bsLastXp=0 %;\
   /set bsGotXp=0 %;\
   /set bsMonTotalDmg=0 %; /set bsMonHits=0 %;\
   /set bsStartTime=$(/time @) %; /set bsStopTime=0 %;\
   /set bsDelayCnt=%{bsDelay} %;\
   /bsecho InOut started. %;\
   /pHook bsMain %;\
   /if /test !promptEngaged %; /then \
       /bsMain %;\
    /endif

/bsDef Res = \
   /set bsState=on %;\
   /bsecho InOut resumed. %;\
   /pHook bsMain

/bsDef Stop = \
   /set bsState=off %;\
   /bsecho InOut halted. %;\
   /if /test %# %; /then \
       /bsecho %{*} %;\
    /endif

; In/out Report

/bsDef Rep = \
   /if /test bsInOuts==0 %; /then \
       /bsecho No data for report. %;\
       /break %;\
    /endif %;\
   /set bsMisses=$[(bsInOuts-bsHits)] %;\
   /set bsMonMisses=$[(bsInOuts-bsMonHits)] %;\
   /set bsEndTime=$(/time @) %;\
   /if /test bsStopTime!=0 %; /then \
       /set bsEndTime=%{bsStopTime} %;\
    /endif %;\
   /set bsTime=$[(bsEndTime-bsStartTime)] %;\
   /bsecho2 - %;\
   /if /test bsMonName !~ "" %; /then \
       /bsecho2 - In/out Report for %{bsMonName} (%{bsMonster}) %;\
    /else \
       /bsecho2 - In/out Report for %{bsMonster} %;\
    /endif %;\
   /bsecho2 - %;\
   /bsecho2 - ------------ You -------------  ------------ Them ------------ %;\
   /bsecho2 - Hits$(/uFr %{bsHits} 25)  Hits$(/uFr %{bsMonHits} 25) %;\
   /bsecho2 - Misses$(/uFr %{bsMisses} 23)  Misses$(/uFr %{bsMonMisses} 23) %;\
   /bsecho2 - Damage$(/uFr %{bsTotalDmg} 23)  Damage$(/uFr %{bsMonTotalDmg} 23) %;\
   /bsecho2 - Avg Damage/attack$(/uFr $(/uDiv 2 %{bsTotalDmg} %{bsInOuts}) 12)  Avg Damage/attack$(/uFr $(/uDiv 2 %{bsMonTotalDmg} %{bsInOuts}) 12) %;\
   /bsecho2 - Avg Damage/hit$(/uFr $(/uDiv 2 %{bsTotalDmg} %{bsHits}) 15)  Avg Damage/hit$(/uFr $(/uDiv 2 %{bsMonTotalDmg} %{bsMonHits}) 15) %;\
   /bsecho2 - Approx Damage/sp$(/uFr $(/uDiv 2 %{bsTotalDmg} $[(bsHits*bsSpNeeded)+(bsMisses*bsSpFail)]) 13) %;\
   /bsecho2 - Approx Damage/second$(/uFr $(/uDiv 2 %{bsTotalDmg} %{bsTime}) 9) %;\
   /bsecho2 - ------------------------------  ------------------------------ %;\
   /bsecho2 - %;\
   /bsecho2 - Number of In/outs$(/uFr %{bsInOuts} 12)  Total time$(/uFr $(/uPrintTime %{bsTime}) 19)  %;\
   /bsecho2 - %;\
   /bsecho2 - Combat Xp$(/uFr $[bsTotalDmg*2] 20) %;\
   /bsecho2 - Kill Xp$(/uFr %{bsDiedXp} 22) %;\
   /bsecho2 - Total Xp$(/uFr $[bsTotalDmg*2+bsOtherXp+bsDiedXp] 21)  XP/second$(/uFr $(/uDiv 2 $[bsTotalDmg*2+bsDiedXp] %{bsTime}) 20) %;\
   /bsecho2 -

; Monster specific setup

/bsDef Set = \
   /if /test %{#} == 0 %; /then \
       /bsecho2 - %;\
       /if /test bsMonName =~ "" %; /then \
           /bsecho2 - Current Settings for %{bsMonster} %;\
        /else \
           /bsecho2 - Current Settings for %{bsMonName} (%{bsMonster}) %;\
        /endif %;\
       /bsecho2 - %;\
       /bsecho2 - In: %{bsIndir}  Out: %{bsOutdir} %;\
       /bsecho2 - Location: %{bsMonLoc} %;\
       /if /test bsReady !~ "" %; /then \
           /bsecho2 - Ready to kill: %{bsReady} %;\
        /endif %;\
    /else \
       /set bsIndir=%{1} %;\
       /set bsMonster=%{2} %;\
       /set bsOutdir=%{3} %;\
       /set bsMonLoc=%{4} %;\
       /bsSetShort %;\
       /set bsDoMacro=0 %;\
    /endif

/bsDef SetIn = \
   /set bsIndir=%{*} %;\
   /bsSetShort

/bsDef SetMonster = \
   /set bsMonster=%{*} %;\
   /bsSetShort

/bsDef SetOut = \
   /set bsOutdir=%{*} %;\
   /bsSetShort

/bsDef SetReady = \
   /set bsReady=$(/escape . %{*}) %;\
   /bsecho Ready to kill string set to: %{bsReady}

/bsDef SetMonLoc = \
   /set bsMonLoc=%{*} %;\
   /bsecho Monster location set to: %{bsMonLoc}

/bsDef SetShort = \
   /bsecho In: %{bsIndir}  Monster: %{bsMonster}  Out: %{bsOutdir} %;\
   /if /test bsMonLoc !~ "" %; /then \
       /bsecho Location: %{bsMonLoc} %;\
    /endif

; General setup

/bsDef SetDelay = \
   /if /test %{#} != 0 %; /then \
       /set bsDelay=%{*} %;\
    /endif %;\
   /bsecho Delay: %{bsDelay} rounds.

/bsDef Gen = \
  /if /test %# == 0 %; /then \
      /bsecho2 | %;\
      /bsecho2 | General settings %;\
      /bsecho2 | %;\
      /bsecho2 |        Spell: %{bsAttack} %;\
      /bsecho2 | Casting cost:$(/uFr %{bsSpNeeded} 4)   Fail cost:$(/uFr %{bsSpFail} 3) %;\
      /bsecho2 | %;\
      /bsecho2 | Hitpoint cap:$(/uFr %{bsHpcap} 4) %;\
      /bsecho2 | %;\
      /bsecho2 | InOut is %{bsType}. %;\
      /bsecho2 | %;\
   /else \
      /set bsAttack=%{1} %;\
      /set bsSpNeeded=%{2} %;\
      /set bsSpFail=%{3} %;\
      /set bsHpcap=%{4} %;\
      /bsecho Attack: %{1}  Cast cost: %{2}  Fail cost: %{3}  HP cap: %{4} %;\
   /endif

/bsDef Inform = \
   /if /test %{#} != 0 %; /then \
     /if /test {1} =~ "off" %; /then \
       /set bsInform=off %;\
     /else \
       /set bsInform=on %;\
     /endif %;\
   /endif %;\
   /bsecho Backstab Reporting: %{bsInform}.
   


/bsDef HpCap = \
   /if /test {1} !~ "" %; /then \
     /set bsHpCap %{1} %;\
   /endif %;\
   /bsecho HpCap: %{bsHpCap}
     
/bsDef Gag = \
   /if /test "%{1}"=~"on" %; /then \
       /set bsGag=on %;\
    /elseif /test "%{1}"=~"off" %; /then \
       /set bsGag=off %;\
    /endif %;\
   /bsecho Inout gagging %{bsGag}.

;
; Convience macros
;

; Peek - if hp above hpmin, in, look at monster, out
        
/bsDef Peek = \
   /if /test HP > bsHpCap %; /then \
       /eval %{bsIndir}\10look at %{bsMonster}\10%{bsOutdir} %;\
       /test 1 %;\
    /else \
       /bsecho HP too low. %;\
       /test 0 %;\
    /endif

; gc: if hp above hpmin, in, get all from corpse, out

/bsDef gc = \
   /if /test HP > bsHpCap %; /then \
       /bsGoIn get all from corpse %;\
       /test 1 %;\
    /else \
       /bsecho HP too low. %;\
       /test 0 %;\
    /endif

; Sigil: if hp above hpmin, in, sigil monster, out

/bsDef Sigil = \
   /if /test HP > bsHpCap %; /then \
       /bsGoIn sigil %{bsMonster} %;\
       /test 1 %;\
    /else %;\
       /bsecho HP too low. %;\
       /test 0 %;\
    /endif
  
; Echo macros

/bsDef Echo = \
   /bsEcho2 * %{*}

/bsDef Echo2 = \
   /echo -aB -- %{*}

; Quit macro

/bsDef Quit = \
   /for i $(/car %{bs_res}) $(/cdr %{bs_res}) /undefn %%{i} %;\
   /mapcar /unset bsState bsGag bsDelay bsDelayCnt bsLock bsAuto \
                  bsDiedFlag bsInHp bsStartTime bsEndTime bsStopTime \
                  bsMonster bsReady bsHpcap bsSpNeeded bsInouts bsActionQ \
                  bsCurXp bsGold bsLastXp bsDiedXp bsMisses bsTime \
                  bsMonLoc bsAttack bsHits bsTotalDmg bsGotXp bsOtherXp \
                  bsMonTotalDmg bsMonHits bsMonMisses bsIndir bsOutdir \
                  bsSpFail bs_tf bs_res %;\
   /purge -i bsDieHook %;\
   /echo % bs.tf removed.

/eval /set bs_res=%{bs_res} %?

; Hooks

/def bsDieHook

; Startup message

/bsecho Bs.tf ready.

/def -Fp9999 -t'*you*burst*shadows*' bsBsTried1 = /set bsDelay=%{bsDelayHit}
/def -Fp9999 -mregexp -t'Endurance Cost per Weapon per Hit: ([0-9]*)' bsCost = \
  /set bsDelayHit=$[{P1}/22]%;/set bsSpNeeded=$[{P1}*2]%;/set bsSpFail=$[bsSpNeeded/5]


/bsdef SetMacro = \
    /set bsDoMacro=1 %;\
    /set bsMacro=%{*} %;\

