
;
; Heal.tf
;
; Heal system, takes advantage of makepath, allows coins to be "hidden"
; in a container, and auto-withdraws if desired.
;
; Requires makepath.tf and util.tf v0.1
;
; Questions, comments, criticisms to Symbolic.
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: util.tf v0.8 required for heal.tf %;\
 /endif

/if /test makepath_tf < 25 %; /then \
    /echo % WARNING: makepath.tf v2.5 required for heal.tf %;\
 /endif

/set heal_tf=22

/def -i healVer = /echo @(#) heal.tf  v2.2  (08/01/96)

/eval /set heal_res=%?

/def -i hDef = /def -i %{*}

/hDef healDef = \
   /set healMacros=%{1} %{healMacros} %;\
   /hdef %{1} = \
      /let cost=$$[ %{4} * %%{1-1} ] %%;\
      /mpMark heal %%;\
      /healDoAuto %%{cost} %%;\
      /goto %{3} %%;\
      /healHide1 %%{cost} %%;\
      /for i 1 %%{1-1} %{-4} %%;\
      /healHide2 %%;\
      /healCheckCoins %%;\
      /goto mark heal

/hDef hEcho = /echo -aB * %{*}

; Init

/hDef healReset = \
   /set healContainer=bag %;\
   /set healHide=off %;\
   /set healGold= %;\
   /set healHiddenGold= %;\
   /set healAuto=off

/healReset

; Coin hiding

/hDef Hide = \
   /if /test %{#} %; /then \
       /let arg=%{1} %;\
       /if /test arg =~ "on" %; /then \
           /set healHide=on %;\
           put all coins in %{healContainer} %;\
        /elseif /test arg =~ "off" %; /then \
           /set healHide=off %;\
           get all coins from %{healContainer} %;\
        /else \
           /set healHide=on %;\
           /set healContainer=%{*} %;\
           put all coins in %{healContainer} %;\
        /endif %;\
       /healCheckCoins %;\
     /endif %;\
   /if /test healHide =~ "on" %; /then \
       /hecho Coin hide on. %;\
       /hecho Coins will be kept in %{healContainer}. %;\
    /else \
       /hecho Coin hide off. %;\
    /endif %;\

/hDef healHide1 = \
   /if /test healHide =~ "on" %; /then \
       get %{1} coins from %{healContainer} %;\
    /endif

/hDef healHide2 = \
   /if /test healHide =~ "on" %; /then \
       put all coins in %{healContainer} %;\
       get 200 coins from %{healContainer} %;\
    /endif

; Allows the buy command to work when coin hide is on.

/hDef -h'SEND buy *' healBuyHook = \
   /healHide1 all %;\
   /send buy %{-1} %;\
   /healHide2

/hDef -h'SEND hbuy *' healBuyHook2 = \
   /send buy %{-1}

/hDef -h'SEND give * coins *' healGiveHook = \
   /healHide1 %{2} %;\
   /send %{*} %;\
   /healHide2
   
; Update healGold/healHiddenGold

/hDef healCheckCoins = \
   /uaPutQ healCheck1 %;\
   /uaPutQ healCheck2 %;\
   /if /test healHide =~ "on" %; /then \
       /send %{uActCmd}\10look in %{healContainer}\10..\10%{uActCmd} %;\
    /else \
       /send %{uActCmd}\10..\10%{uActCmd} %;\
    /endif

/hDef healCheck1 = \
   /def -mregexp -i -p88888 -1 -ag -t'([0-9]*) gold coins' healCheckTrig = \
      /set healHiddenGold=%%{P1} %;\
   /def -mregexp -i -p88888 -1 -ag -t'XP : (.*), GD : ([0-9]*)' healCheckTrig2 = \
      /set healGold=%%{P2} %;\
   /uGagOn

/hDef healCheck2 = \
   /purge -i healCheckTrig %;\
   /purge -i healCheckTrig2 %;\
   /uGagOff

; Auto withdrawing of coins.

/hDef AutoWithdraw = \
   /if /test %# %; /then \
       /let arg=%{1} %;\
       /if /test arg =~ "on" %; /then \
           /set healAuto=on %;\
           /healCheckCoins %;\
        /elseif /test arg =~ "off" %; /then \
           /set healAuto=off %;\
        /else \
           /set healAuto=on %;\
           /set healAutoAmount=%{*} %;\
           /healCheckCoins %;\
        /endif %;\
     /endif %;\
   /if /test healAuto =~ "on" %; /then \
       /hecho Auto withdraw on. %;\
       /hecho %{healAutoAmount} coins will be withdrawn. %;\
    /else \
       /hecho Auto withdraw off. %;\
    /endif

/hDef healDoAuto = \
   /let amount=%{1} %;\
   /if /test ( ($[(healGold+healHiddenGold)]< amount) & (healAuto =~ "on") ) %; /then \
       /eval /goto cbank %%;\
             withdraw %{healAutoAmount} %%;\
             /healHide2 %;\
    /endif

; Execute a specified heal macro and call specified macros on finish/fail.

/hDef healDo = \
   /def -i -ag -1 -Fp99998 -mregexp -t'HP : ([0-9]*).* : ([0-9]*)' healPre = \
      /set healPreHP=%%{P1} %%;\
      /set healPreSP=%%{P2} %;\
   /def -i -ag -1 -Fp99997 -mregexp -t'HP : ([0-9]*).* : ([0-9]*)' healTest = \
      /let healHP=%%{P1} %%;\
      /let healSP=%%{P2} %%;\
      /if /test $$[healHP-healPreHP] > 20 | $$[healSP-healPreSP] > 50 %%; /then \
          /uCallVarHook healOk %%;\
       /else \
          /uCallVarHook healFail %%;\
       /endif %%;\
      /mapcar /unset healPreHP healPreSP healOk healFail %;\
   /send . %;\
   /eval /%{1} %;\
   /send . %;\
   /set healOk=%{2} %;\
   /set healFail=%{3}

; Help

/hdef healHelp = \
   /hEcho %;\
   /hEcho Heal.tf Help %;\
   /hEcho %;\
   /hEcho /hide (container|on|off)                   - Turn coin hiding on/off. %;\
   /hEcho /autowithdraw (amount|on|off)              - Turn auto withdrawing on/off. %;\
   /hEcho /healdef (name) = (place) (cost) (command) - Create new heal macro. %;\
   /hEcho %;\
   /hEcho Currently installed healing macros: %;\
   /hEcho %{healMacros} %;\
   /hEcho

; Quit

/hDef healQuit = \
   /for i $(/car %{heal_res}) $(/cdr %{heal_res}) /undefn %%{i} %;\
   /foreach healMacros /purge -i %;\
   /mapcar /unset heal_tf heal_res healMacros healOk healFail healContainer \
                  healAuto healGold healHiddenGold healHP healPreHP \
                  healSP healPreSP healAutoAmount %;\
   /echo % heal.tf removed.

/eval /set heal_res=%{heal_res} %?

;
; Healing macros
;
; All accept number to buy as a parameter, 1 is assumed.
;

/healDef venom  = kente   1800  hbuy venom
/healDef epthal = kente   1900  hbuy epthal
/healDef scana  = kente   2400  hbuy scana
/healDef glogg  = gunter  6100  hbuy glogg
/healDef bs     = pub     2200  hbuy smorgasbord
/healDef frog   = gunter  4300  hbuy frog
/healDef nib    = gunter  2900  hbuy nib
/healDef glogg  = gunter  6100  hbuy glogg
/healDef bh     = booth      0  heal
/healDef asx    = krinfex 1650  hbuy asx
/healDef cass   = cassidy  550  pray

/healDef saddle = meat    2300  hbuy saddle of lamm

/def -i sp = \
  /let oldLoc=%{mpCurLoc} %;\
  /g cath %;\
  /at roof get $[2300*{1-1}+375] coins %;\
  /at Drinks /for i 1 %{1-1} \
                 /uGag buy jug of manischewitz\10guzzle jug\10recycle jug %;\
  /at pub buy coffee %;\
  /g %{oldLoc} 

/hEcho Heal.tf ready.

