
;
; Io.tf
;
; In/out triggers for Overdrive mages, automatic in/outing of a monster.
;
; Requires util.tf and prompt.tf
;
; Questions, comments, criticisms to Symbolic.
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: util.tf v0.8 required for io.tf %;\
 /endif

/if /test prompt_tf < 13 %; /then \
    /echo % WARNING: prompt.tf v1.1 required for io.tf %;\
 /endif

/set io_tf=33
/def -i ioVer = /echo @(#) io.tf version 3.3 (10/25/96)

/eval /set io_res=%?

/def -i ioDef = /def -i io%{*}

/def -i ioActDef = /def -i ioAction%{*}

; Initalize variables.

/ioDef Reset = \
  /set ioState=off %;\
  /set ioGag=off %;\
  /set ioDelay=0 %;\
  /set ioLock=0 %;\
  /set ioAuto=0 %;\
  /set ioDiedFlag=0

/ioReset

; 
; Main 
;
; Updates monster damage/hits/misses, performs in/out if able,
; executes HpHook and SpHook if auto is on.
;

/ioDef Main = \
   /if /test ioInHp %; /then \
       /let ioDmg=$[ioInHp-HP] %;\
       /if /test ioDmg > 0 %; /then \
           /ioecho2 <<< Damage taken: %{ioDmg} >>> %;\
           /set ioMonTotalDmg=$[ioMonTotalDmg+ioDmg] %;\
           /set ioMonHits=$[(ioMonHits + 1)] %;\
        /endif %;\
       /set ioInHp= %;\
    /endif %;\
   /if /test ioDiedFlag %; /then \
       /ioMonDead %;\
    /endif %;\
   /if /test ioState=~"off" %; /then \
       /pUnHook Main %;\
       /break %;\
    /endif %;\
   /if /test !ioLock & !promptEngaged %; /then \
       /if /test ioState=~"off" %; /then \
           /break %;\
        /endif %;\
       /if /test HP < ioHpcap %; /then \
           /ioAutoHeal Hp %;\
        /elseif /test SP < ioSpNeeded %; /then \
                /ioAutoHeal Sp %;\
        /else \
               /set ioDelayCnt=$[ioDelayCnt + 1] %;\
               /if /test ioDelayCnt > ioDelay %; /then \
                       /ioDo %;\
                    /endif %;\
        /endif %;\
    /endif

; Executes heal macro if auto is enabled.

/iodef AutoHeal = \
   /if /test ioAuto %; /then \
       /ioLock io.tf/ioAutoHeal: executing %{1}Hook. %;\
       /eval /healDo %{1}Hook ioHealOk ioHealFail %;\
    /endif

; Macros executed on success/fail of heal macro.

/ioDef HealOk = \
   /ioRelease

/ioDef HealFail = \
   /ioStop HP/SP macro failed! %;\
   /ioRelease

; Lock/Release: use to _temporarily_ prevent in/outting

/ioDef Lock = \
   /set ioLock=$[ioLock+1] %;\
   /set ioLock%{ioLock}=%{*} 

/ioDef Release = \
   /if /test ioLock > 0 %; /then \
       /set ioLock=$[ioLock-1] %;\
    /endif
    
/ioDef ShowLock = \
   /if /test ioLock == 0 %; /then \
       /ioecho No locks present. %;\
    /else \
       /for i 1 %{ioLock} /eval /ioecho %%%{ioLock%%{i}} %;\
    /endif 

; Do: actually sends in/out commands to mud

/ioDef Do = \
   /if /test ioLock == 0 %; /then \
       /ioaPutQ In %; /ioaPutQ Out %;\
       /ioLock io.tf/ioDo: executing in/out. %;\
       /if /test ioInOuts==0 | mageInvis=~"on" %; /then \
           /ioGoIn %{ioAttack} %{ioMonster} %;\
        /else \
           /ioGoIn %{ioAttack} %{ioMonster} %;\
        /endif %;\
        /set promptEngaged=0 %;\
    /endif

/ioDef GoIn = \
       /if /test ioMonLoc !~ "" & ioMocLoc !~ mpCurLoc %; /then \
          /mpMark io %;\
          /goto %{ioMonLoc} %;\
          /let doReturn=1 %;\
       /else \
          /let doReturn=0 %;\
       /endif %;\
       /if /test !ioDoMacro %;/then \
         /eval ..\10%{ioIndir}\10%{*}\10%{ioOutdir}\10.. %;\
       /else \
         /eval ..%;/%{ioMacro}%;stealth off%;.. %;\
       /endif %;\
       /if /test doReturn %; /then \
          /goto mark io%;\
       /endif %;\

; Action queue system
;
; Execute actions out of queue on .. display.

/ioDef aGetQ = /uGetQ ioActionQ
/ioDef aPutQ = /uPutQ %{1} ioActionQ
/ioDef aClearQ = /set ioActionQ=

/def -i -p100 -ag -mregexp -t'XP : ([0-9]*)  .([0-9]*) left to spend., GD : ([0-9]*)' \
     ioActionTrig = \
   /set ioCurXp=%P1 %; /set ioGold=%P3 %;\
   /let action=$(/ioaGetQ) %;\
   /if /test action=~"" %; /then \
       /let ioT=$[(ioCurXp-ioLastXp)/2] %;\
       /if /test ioT > 0 %; /then \
          /echo -aB -- <<< Damage done: %{ioT} >>> %;\
       /endif %;\
       /echo XP : %P1  (%P2 left to spend), GD : %P3 %;\
    /else \
       /eval /ioAction%{action} %;\
    /endif %;\
   /set ioLastXp=%{ioCurXp}

; ActionIn: executed before in/out, initializes vars

/ioActDef In = \
   /set ioDiedXp=0 %;\
   /set ioInHp=%{HP} %;\
   /if /test ioGag=~"on" & ioInOuts!=0 %; /then \
       /uGagOn %;\
    /endif

; ActionOut: executed after in/out, records damage data, checks for monster 
;            death

/ioActDef Out = \
   /uGagOff %;\
   /ioRelease %;\
   /let ioDmg=$[(ioCurXp-ioLastXp)/2] %;\
   /if /test iograph_tf > 0 %; /then \
       /eval /set ioDmgAry_%{ioDmg}=$$[(ioDmgAry_%{ioDmg}+1)] %;\
    /endif %;\
   /ioecho2 <<< Damage done: %{ioDmg} >>> %;\
   /if /test ioDmg > 0 %; /then \
       /set ioHits=$[(ioHits+1)] %;\
    /endif %;\
   /set ioInOuts=$[(ioInOuts+1)] %;\
   /set ioTotalDmg=$[(ioTotalDmg+ioDmg)] %;\
   /set ioDelayCnt=0 

; Monster death and experience triggers

/def -i -mglob -t'* died.' ioDied = \
    /if /test ioState!~"off" %; /then \
        /set ioDiedFlag=1 %;\
     /endif

/def -i -mregexp -t'You .* ([0-9]*) experience' \
      ioGetXp = \
   /let TempXp=%{P1} %;\
   /if /test ioState!~"off" %; /then \
       /set ioGotXp=$[(TempXp+ioGotXp)] %;\
       /set ioLastXp=$[(ioLastXp+TempXp)] %;\
    /endif

/iodef MonDead = \
    /if /test ioGotXp!=0 %; /then \
        /set ioDiedXp=%{ioGotXp} %; /set ioGotXp= %;\
        /set ioStopTime=$(/time @) %;\
        /ioStop %;\
        /ioDieHook %;\
        /uaPutQ ioReport %; /send %{uActCmd} %;\
     /endif %;\
    /set ioDiedFlag=0 %;\

;
; In/out control macros
;
; ioStart - Initalize all variables, start in/out
; ioRes   - Resume in/out
; ioStop  - Stop in/out
;

/ioDef Start = \
   /set ioState=on %;\
   /set ioTotalDmg=0 %; /set ioInOuts=0 %; /set ioHits=0 %;\
   /set ioOtherXp=0 %; /set ioDiedXp=0 %; /set ioLastXp=0 %;\
   /set ioGotXp=0 %;\
   /set ioMonTotalDmg=0 %; /set ioMonHits=0 %;\
   /set ioStartTime=$(/time @) %; /set ioStopTime=0 %;\
   /set ioDelayCnt=%{ioDelay} %;\
   /ioecho InOut started. %;\
   /pHook ioMain %;\
   /if /test !promptEngaged %; /then \
       /ioMain %;\
    /endif

/ioDef Res = \
   /set ioState=on %;\
   /ioecho InOut resumed. %;\
   /pHook ioMain

/ioDef Stop = \
   /set ioState=off %;\
   /ioecho InOut halted. %;\
   /if /test %# %; /then \
       /ioecho %{*} %;\
    /endif

; In/out Report

/ioDef Report = \
   /if /test ioInOuts==0 %; /then \
       /ioecho No data for report. %;\
       /break %;\
    /endif %;\
   /set ioMisses=$[(ioInOuts-ioHits)] %;\
   /set ioMonMisses=$[(ioInOuts-ioMonHits)] %;\
   /set ioEndTime=$(/time @) %;\
   /if /test ioStopTime!=0 %; /then \
       /set ioEndTime=%{ioStopTime} %;\
    /endif %;\
   /set ioTime=$[(ioEndTime-ioStartTime)] %;\
   /ioecho2 - %;\
   /if /test ioMonName !~ "" %; /then \
       /ioecho2 - In/out Report for %{ioMonName} (%{ioMonster}) %;\
    /else \
       /ioecho2 - In/out Report for %{ioMonster} %;\
    /endif %;\
   /ioecho2 - %;\
   /ioecho2 - ------------ You -------------  ------------ Them ------------ %;\
   /ioecho2 - Hits$(/uFr %{ioHits} 25)  Hits$(/uFr %{ioMonHits} 25) %;\
   /ioecho2 - Misses$(/uFr %{ioMisses} 23)  Misses$(/uFr %{ioMonMisses} 23) %;\
   /ioecho2 - Damage$(/uFr %{ioTotalDmg} 23)  Damage$(/uFr %{ioMonTotalDmg} 23) %;\
   /ioecho2 - Avg Damage/attack$(/uFr $(/uDiv 2 %{ioTotalDmg} %{ioInOuts}) 12)  Avg Damage/attack$(/uFr $(/uDiv 2 %{ioMonTotalDmg} %{ioInOuts}) 12) %;\
   /ioecho2 - Avg Damage/hit$(/uFr $(/uDiv 2 %{ioTotalDmg} %{ioHits}) 15)  Avg Damage/hit$(/uFr $(/uDiv 2 %{ioMonTotalDmg} %{ioMonHits}) 15) %;\
   /ioecho2 - Approx Damage/sp$(/uFr $(/uDiv 2 %{ioTotalDmg} $[(ioHits*ioSpNeeded)+(ioMisses*ioSpFail)]) 13) %;\
   /ioecho2 - Approx Damage/second$(/uFr $(/uDiv 2 %{ioTotalDmg} %{ioTime}) 9) %;\
   /ioecho2 - ------------------------------  ------------------------------ %;\
   /ioecho2 - %;\
   /ioecho2 - Number of In/outs$(/uFr %{ioInOuts} 12)  Total time$(/uFr $(/uPrintTime %{ioTime}) 19)  %;\
   /ioecho2 - %;\
   /ioecho2 - Combat Xp$(/uFr $[ioTotalDmg*2] 20) %;\
   /ioecho2 - Kill Xp$(/uFr %{ioDiedXp} 22) %;\
   /ioecho2 - Total Xp$(/uFr $[ioTotalDmg*2+ioOtherXp+ioDiedXp] 21)  XP/second$(/uFr $(/uDiv 2 $[ioTotalDmg*2+ioDiedXp] %{ioTime}) 20) %;\
   /ioecho2 -

; Monster specific setup

/ioDef Set = \
   /if /test %{#} == 0 %; /then \
       /ioecho2 - %;\
       /if /test ioMonName =~ "" %; /then \
           /ioecho2 - Current Settings for %{ioMonster} %;\
        /else \
           /ioecho2 - Current Settings for %{ioMonName} (%{ioMonster}) %;\
        /endif %;\
       /ioecho2 - %;\
       /ioecho2 - In: %{ioIndir}  Out: %{ioOutdir} %;\
       /ioecho2 - Location: %{ioMonLoc} %;\
       /if /test ioReady !~ "" %; /then \
           /ioecho2 - Ready to kill: %{ioReady} %;\
        /endif %;\
    /else \
       /set ioIndir=%{1} %;\
       /set ioMonster=%{2} %;\
       /set ioOutdir=%{3} %;\
       /set ioMonLoc=%{4} %;\
       /ioSetShort %;\
    /endif

/ioDef SetIn = \
   /set ioIndir=%{*} %;\
   /ioSetShort

/ioDef SetMonster = \
   /set ioMonster=%{*} %;\
   /ioSetShort

/ioDef SetOut = \
   /set ioOutdir=%{*} %;\
   /ioSetShort

/ioDef SetReady = \
   /set ioReady=$(/escape . %{*}) %;\
   /ioecho Ready to kill string set to: %{ioReady}

/ioDef SetMonLoc = \
   /set ioMonLoc=%{*} %;\
   /ioecho Monster location set to: %{ioMonLoc}

/ioDef SetShort = \
   /ioecho In: %{ioIndir}  Monster: %{ioMonster}  Out: %{ioOutdir} %;\
   /if /test ioMonLoc !~ "" %; /then \
       /ioecho Location: %{ioMonLoc} %;\
    /endif

; General setup

/ioDef SetDelay = \
   /if /test %{#} != 0 %; /then \
       /set ioDelay=%{*} %;\
    /endif %;\
   /ioecho Delay: %{ioDelay} rounds.

/ioDef Gen = \
  /if /test %# == 0 %; /then \
      /ioecho2 | %;\
      /ioecho2 | General settings %;\
      /ioecho2 | %;\
      /ioecho2 |        Spell: %{ioAttack} %;\
      /ioecho2 | Casting cost:$(/uFr %{ioSpNeeded} 4)   Fail cost:$(/uFr %{ioSpFail} 3) %;\
      /ioecho2 | %;\
      /ioecho2 | Hitpoint cap:$(/uFr %{ioHpcap} 4) %;\
      /ioecho2 | %;\
      /ioecho2 | InOut is %{ioType}. %;\
      /ioecho2 | %;\
   /else \
      /set ioAttack=%{1} %;\
      /set ioSpNeeded=%{2} %;\
      /set ioSpFail=%{3} %;\
      /set ioHpcap=%{4} %;\
      /ioecho Attack: %{1}  Cast cost: %{2}  Fail cost: %{3}  HP cap: %{4} %;\
   /endif

/ioDef Gag = \
   /if /test "%{1}"=~"on" %; /then \
       /set ioGag=on %;\
    /elseif /test "%{1}"=~"off" %; /then \
       /set ioGag=off %;\
    /endif %;\
   /ioecho Inout gagging %{ioGag}.

;
; Convience macros
;

; Peek - if hp above hpmin, in, look at monster, out
        
/ioDef Peek = \
   /if /test HP > ioHpCap %; /then \
       /eval %{ioIndir}\10look at %{ioMonster}\10%{ioOutdir} %;\
       /test 1 %;\
    /else \
       /ioecho HP too low. %;\
       /test 0 %;\
    /endif

; gc: if hp above hpmin, in, get all from corpse, out

/ioDef gc = \
   /if /test HP > ioHpCap %; /then \
       /ioGoIn get all from corpse %;\
       /test 1 %;\
    /else \
       /ioecho HP too low. %;\
       /test 0 %;\
    /endif

; Sigil: if hp above hpmin, in, sigil monster, out

/ioDef Sigil = \
   /if /test HP > ioHpCap %; /then \
       /ioGoIn sigil %{ioMonster} %;\
       /test 1 %;\
    /else %;\
       /ioecho HP too low. %;\
       /test 0 %;\
    /endif
  
; Echo macros

/ioDef Echo = \
   /ioEcho2 * %{*}

/ioDef Echo2 = \
   /echo -aB -- %{*}

; Quit macro

/ioDef Quit = \
   /for i $(/car %{io_res}) $(/cdr %{io_res}) /undefn %%{i} %;\
   /mapcar /unset ioState ioGag ioDelay ioDelayCnt ioLock ioAuto \
                  ioDiedFlag ioInHp ioStartTime ioEndTime ioStopTime \
                  ioMonster ioReady ioHpcap ioSpNeeded ioInouts ioActionQ \
                  ioCurXp ioGold ioLastXp ioDiedXp ioMisses ioTime \
                  ioMonLoc ioAttack ioHits ioTotalDmg ioGotXp ioOtherXp \
                  ioMonTotalDmg ioMonHits ioMonMisses ioIndir ioOutdir \
                  ioSpFail io_tf io_res %;\
   /purge -i ioDieHook %;\
   /echo % io.tf removed.

/eval /set io_res=%{io_res} %?

; Hooks

/def ioDieHook

; Startup message

/ioecho Io.tf ready.
