
;
; Mage.tf
;
; Triggers/macros useful to a mage.
;
; Requires util.tf v0.8 and prompt.tf v1.1, prevents io.tf from in/outting
; (if loaded) as necessary.
;
; Questions, comments, criticisms to Symbolic.
; Thanks to Mhoram for much of the work!
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: mage.tf requires util.tf v0.8 %;\
 /endif

/if /test prompt_tf < 13 %; /then \
    /echo $ WARNING: mage.tf requires prompt.tf v1.3 %;\
 /endif

/set mage_tf=11

/def -i mageDef = /def -i %{*}

/eval /set mage_res=%?

/mageDef mageVer = /echo @(#) mage.tf  v1.1  (10/25/96)

; Initalize variables.

/mageDef mageReset = \
   /set mageStoneskinStatus=? %;\
   /set mageStoneskinHP=0 %;\
   /set mageArmorStatus=? %;\
   /set mageArmorType=general %;\
   /set mageArmor=off %;\
   /set mageBlurStatus=dunno %;\
   /set mageBlur=off %;\
   /set mageInvisStatus=dunno %;\
   /set mageInvis=off %;\
   /set mageAuraStatus=dunno %;\
   /set mageAura=off %;\
   /set mageLock1=0 %;\
   /set mageLock2=0 %;\
   /set mageLock3=0 %;\
   /set mageLock4=0 %;\
   /set mageLock5=0 %;\

/mageReset

/mageDef mageMain = \
   /if /test HP < mageStoneskinHP %; /then \
       /if /test mageStoneskinStatus!~"yes" %; /then \
           /mageLock 1 %;\
           /if /test SP >= 70 %; /then \
              /pSend stoneskin %;\
            /else \
              /pNextQ mageMain %;\
            /endif %;\
         /break %;\
        /endif %;\
   /elseif /test mageInvis!~"off" & mageInvisStatus!~"on" %; /then \
       /mageLock 4 %;\
       /if /test SP >= 50 %; /then \
           /pSend invis %;\
        /else \
           /pNextQ mageMain %;\
        /endif %;\
       /break %;\
   /elseif /test mageArmor!~"off" & mageArmorStatus!~"on" %; /then \
       /mageLock 2 %;\
       /if /test SP >= 40 %; /then \
           /pSend armor %{mageArmorType} %;\
        /else \
           /pNextQ mageMain %;\
        /endif %;\
       /break %;\
   /elseif /test mageBlur!~"off" & mageBlurStatus!~"on" %; /then \
       /mageLock 3 %;\
       /if /test SP >= 50 %; /then \
           /pSend blur %;\
        /else \
           /pNextQ mageMain %;\
        /endif %;\
       /break %;\
   /elseif /test mageAura!~"off" & mageAuraStatus!~"on" %; /then \
       /mageLock 5 %;\
       /if /test SP >= 60 %; /then \
           /pSend aura %;\
        /else \
           /pNextQ mageMain %;\
         /endif %;\
        /break %;\
   /else \
        /pClearQ mageMain %;\
   /endif

; Lock/release io.tf if present

/mageDef mageLock = \
   /if /test mageLock%{1}==0 %; /then \
         /if /test io_tf >= 30 %; /then \
             /ioLock mage.tf/mageLock: lock #%{1} %;\
             /eval /set mageLock%{1}=1 %;\
         /endif %;\
   /endif

/mageDef mageRelease = \
   /if /test mageLock%{1} > 0 %; /then \
       /if /test io_tf >= 30 %; /then \
           /ioRelease %;\
           /eval /set mageLock%{1}=0 %;\
       /endif %;\
    /endif

; Stoneskin triggers/macros

/mageDef SetSS = \
   /if /test "%{1}"=~"off" %; /then \
       /set mageStoneskinHP=0 %;\
       /mageRelease 1 %;\
    /elseif /test %# %; /then \
       /set mageStoneskinHP=%{1} %;\
       /pPutQ mageMain %;\
    /endif %;\
   /if /test mageStoneskinHP!=0 %; /then \
       /mageecho Auto stoneskin on. %;\
       /mageecho Stoneskin at %{mageStoneskinHP} and under. %;\
    /else \
       /mageecho Auto stoneskin off. %;\
    /endif

/mageDef mageStoneskinOn = \
   /set mageStoneskinStatus=yes %;\
   /mageRelease 1 %;\
   /pPutQ mageMain

/mageDef mageStoneskinOff = \
   /set mageStoneskinStatus=no %;\
   /if /test mageStoneskinHP > 0 %; /then \
       /mageLock 1 %;\
    /endif %;\
   /pPutQ mageMain
   
/def -i -t'*ou invoke the stoneskin spell on yourself*' mageStOn = \
   /mageStoneskinOn

/def -i -t'*ou are already protected by this spell*' mageStOn2 = \
   /mageStoneskinOn

/def -i -t'*our skin feels less weird*' mageStOff = \
   /mageStoneskinOff

/def -i -t'*our thick skin takes the blow, then becomes normal again*' mageStOff2 = \
   /mageStoneskinOff

/def -i -t'*he blow penetrates somewhat your magical skin, which vanishes*' mageStOff3 = \
   /mageStoneskinOff

/def -i -t'*he spell seems to sag in the middle, as if it were*' mageStFail = \
   /mageStoneskinOff
   
; Armor/Blur triggers/macros.... Thanks Mhoram. :)

/mageDef Armor = \
    /if /test "%{1}"=~"off" %; /then \
        /set mageArmor=off %;\
        /mageRelease 2 %;\
     /endif %;\
    /if /test "%{1}"=~"on" %; /then \
        /set mageArmor=on %;\
        /pPutQ mageMain %;\
     /endif %;\
    /if /test ("%{1}"=~"general" | "%{1}"=~"crushing" | \
               "%{1}"=~"slashing" | "%{1}"=~"thrusting") %; /then \
        /if /test (mageArmorStatus=~"on" & "%{1}"!~mageArmorType) %; /then \
            dispel aura %;\
         /endif %;\
        /set mageArmorType=%{1} %;\
        /set mageArmor=on %;\
        /pPutQ mageMain %;\
     /endif %;\
    /if /test mageArmor!~"on" %; /then \
        /ioecho Armor off. %;\
     /else \
        /ioecho Armor %{mageArmorType} on. %;\
     /endif

/mageDef mageArmorOn = \
   /set mageArmorStatus=on %;\
   /mageRelease 2 %;\
   /pPutQ mageMain

/mageDef mageArmorOff = \
   /set mageArmorStatus=off %;\
   /if /test mageArmor=~"on" %; /then \
       /mageLock 2 %;\
    /endif %;\
   /pPutQ mageMain

/def -i -t'*ou invoke the spell of protection on yourself*' mageArOn = \
   /mageArmorOn

/def -i -t'*ou are already under a spell of protection*' mageArOn2 = \
   /mageArmorOn

/def -i -t'*ou are surrounded by a magical force*' mageArOn3 = \
   /mageArmorOn

/def -i -t'*our protective spell fails..*' mageArOff = \
   /mageArmorOff

/def -i -t'*ith a minor focus of your will, the aura dissipates*' mageArOff2 = \
   /mageArmorOff

/def -i -t'*ou mouth the words of the spell, but you can f*' mageArFail = \
   /mageArmorOff

/mageDef Aura = \
   /if /test "%{1}"=~"off" %; /then \
       /set mageAura=off %;\
       /mageRelease 5 %;\
    /endif %;\
   /if /test "%{1}"=~"on" %; /then \
       /set mageAura=on %;\
       /pPutQ mageMain %;\
    /endif %;\
   /ioecho Aura %{mageAura}.

/mageDef mageAuraOn = \
   /set mageAuraStatus=on %;\
   /mageRelease 5 %;\
   /pPutQ mageMain

/mageDef mageAuraOff = \
   /set mageAuraStatus=off %;\
   /if /test mageAura=~"on" %; /then \
	/mageLock 5 %;\
   /endif %;\
  /pPutQ mageMain

/def -i -t'*ou speak the arcane words, and a sparkling fiel*' mageAuOn = \
	/mageAuraOn

/def -i -t'*sparkling field floats away on a bre*' mageAuOff = \
	/mageAuraOff

/def -i -t'*ou begin to speak the ancient words, but stop wi*' mgAoff2 = \
	/mageAuraOff

/mageDef Blur = \
   /if /test "%{1}"=~"off" %; /then \
       /set mageBlur=off %;\
       /mageRelease 3 %;\
    /endif %;\
   /if /test "%{1}"=~"on" %; /then \
       /set mageBlur=on %;\
       /pPutQ mageMain %;\
    /endif %;\
   /ioecho Blur %{mageBlur}.

/mageDef mageBlurOn = \
   /set mageBlurStatus=on %;\
   /mageRelease 3 %;\
   /pPutQ mageMain

/mageDef mageBlurOff = \
   /set mageBlurStatus=off %;\
   /if /test mageBlur=~"on" %; /then \
       /mageLock 3 %;\
    /endif %;\
   /pPutQ mageMain

/def -i -t'*ou mouth the words of the spell, and in response the*' mageBlOn = \
   /mageBlurOn

/def -i -t'*he world is very blurry*' mageBlOn2 = \
   /mageBlurOn

/def -i -t'*ou are already very blurry indeed*' mageBlOn3 = \
   /mageBlurOn

/def -i -t'*ou blink and blink and blink, and the haze vanishes*' mageBlOff = \
   /mageBlurOff

/def -i -t'*uddenly, the world comes back into focus*' mageBlOff2 = \
   /mageBlurOff

/def -i -t'*ou incant the spell, but speak the syllables*' mageBlFail = \
   /mageBlurOff

; Invis triggers/macros

/mageDef Invis = \
   /if /test "%{1}"=~"off" %; /then \
       /set mageInvis=off %;\
       /mageRelease 4 %;\
    /endif %;\
   /if /test "%{1}"=~"on" %; /then \
       /set mageInvis=on %;\
       /pPutQ mageMain %;\
    /endif %;\
   /ioecho Invis %{mageInvis}.

/mageDef mageInvisOn = \
   /set mageInvisStatus=on %;\
   /mageRelease 4 %;\
   /pPutQ mageMain

/mageDef mageInvisOff = \
   /set mageInvisStatus=off %;\
   /if /test mageInvis=~"on" %; /then \
       /mageLock 4 %;\
    /endif %;\
   /pPutQ mageMain

/def -i -t'*ou wave your arms wildly while muttering*' mageInvPre = \
   /if /test invForced > 0 %; /then \
     /test invForced := invForced - 1 %;\
   /else \
     /def -i -1 -t'*othing happens*' mageInvFail = \
        /mageInvisOff %%;\
        /purge -i mageInvOn %;\
     /def -i -1 -t'*our whole body tingles*' mageInvOn = \
        /mageInvisOn %%;\
        /purge -i mageInvFail %;\
   /endif %;\

/def -i -t'*ou tingle and shimmer...the invisibility*' mageInvOff = \
   /mageInvisOff

; Can't hurt to check

/def -i -p65535 -F -t'*already engaged this round*' mageCatch = \
   /pClearQ mageMain %;\
   /pPutQ mageMain
   
/def -i -p65535 -F -t'*have the spell points to cast this*' mageCatch2 = \
   /pClearQ mageMain %;\
   /pPutQ mageMain
   
; Echo/Formatting macros

/mageDef mageEcho = \
   /echo -aB -- ! %{*}

; Quit macro

/mageDef mageQuit = \
  /mageecho mage.tf removed. %;\
  /for i $(/car %{mage_res}) $(/cdr %{mage_res}) /undefn %%{i} %;\
  /purge -i mageInvFail %;\
  /purge -i mageInvOn %;\
  /mapcar /unset mageStoneskinHP mageStoneskinStatus \
                 mageArmor mageArmorStatus mageArmorType \
                 mageBlur mageBlurStatus

/eval /set mage_res=%{mage_res} %?


