;
; Makepath.tf
;
; Intelligent movement system including gagging, remembered locations, and
; tracking.
;
; Requires util.tf v0.8.
;
; Questions, comments, criticisms to Symbolic.
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: util.tf v0.8 required for makepath.tf! %;\
 /endif

/set makepath_tf=27

/def -i mpVer = /echo @(#) makepath.tf  v2.7  (11/07/97)

/eval /set makepath_res=%?

/def -i nop = /break
/def -i mpDef2 = /def -i -- %{*}%;/nop

/mpDef2 mpDef = \
   /set mpLocList=%{1} %;\
   /while /shift %; /test ({1} !~ "=" & {#} > 1) %; /do \
      /uPush %{1} mpLocList %;\
      /done %;\
   /if /test {1} !~ "=" %; /then \
       /mpecho Syntax: /mpDef Loc (Loc1) (...) = (path) %;\
       /break %;\
    /endif %;\
   /shift %;\
   /while /test $(/length %{mpLocList}) > 0 %; /do \
      /let Location=$(/uPop mpLocList) %;\
      /let Prefix=$[substr(Location,0,2)] %;\
      /if /test (Prefix =~ "->" | Prefix =~ "<-") %; /then \
          /purge -i -- %{Location} %;\
          /mpDef2 %{Location}=%{*} %;\
       /else \
          /purge -i -- ->%{Location} %;\
          /purge -i -- <-%{Location} %;\
          /mpDef2 ->%{Location}=%{*} %;\
          /mpDef2 <-%{Location}=expand %;\
       /endif %;\
   /done %;\
   /unset mpLocList

/mpDef2 mpDefLoc = \
   /mpDef %{1} =%;\
   /set mpDefLoc=%{1}

/mpDef2 mpAlias = \
   /if /test "%{1}" !~ "" %; /then \
       /set mp_%{1}=%{-1} %;\
       /set mpAliases=%{mpAliases} %{1} %;\
    /else \
       /mpecho Alias                Expands to           Cancels with %;\
       /foreach mpAliases /mpAliasPrint %;\
    /endif

/mpDef2 mpAliasPrint = \
   /mpecho $(/uFl %{1} 20) $(/uFl $(/mpExpand %{1}) 20) $(/mpCancel %{1})

/mpDef2 mpExpand = /eval /cdr %%{mp_%{1}}
/mpDef2 mpCancel = /eval /car %%{mp_%{1}}

/mpDef2 mpEcho = /echo -aB -- * %{*}

; Move macros

/mpDef2 Goto = \
   /if /test "%{1}" =~ "-v" %; /then \
       /let NoGag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "" %; /then \
       /mpecho Goto where? %;\
       /break %;\
    /endif %;\
   /if /test "%{2}" =~ "from" %; /then \
       /set mpTempLoc=%{3} %;\
    /else \
       /set mpTempLoc=%{mpCurLoc} %;\
    /endif %;\
   /if /test mpTempLoc =~ "" %; /then \
       /mpecho Current location unknown! %;\
       /break %;\
    /endif %;\
   /if /test "%{1}" !~ "mark" %; /then \
       /if /mpTest %{mpTempLoc} <- %; /then /break %; /endif %;\
       /if /mpTest %{1} -> %; /then \
           /if /test "%{1}" !~ "mark" %; /then \
               /break %;\
            /endif %;\
        /endif %;\
       /DoMove $(/mpReverse %{mpCurTrack}) <-%{mpTempLoc} ->%{1} %;\
       /set mpCurLoc=%{1} %;\
       /set mpCurTrack= %;\
    /else \
       /eval /DoMove <-%{mpTempLoc} ->%%{mpMarkLoc%{2}} %%{mpMarkTrack%{2}} %;\
       /eval /set mpCurLoc=%%{mpMarkLoc%{2}} %;\
       /eval /set mpCurTrack=%%{mpMarkTrack%{2}} %;\
    /endif %;\
   /unset mpTempLoc

/mpDef2 To = \
   /if /test "%{1}" =~ "-v" %; /then \
       /let NoGag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "" %; /then \
       /mpecho To where? %;\
       /break %;\
    /endif %;\
   /if /mpTest %{1} -> %; /then /break %; /endif %;\
   /DoMove ->%{1} %;\
   /set mpCurLoc=%{1} %;\
   /set mpCurTrack= 

/mpDef2 From = \
   /if /test "%{1}" =~ "-v" %; /then \
       /let NoGag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "" %; /then \
       /mpecho From where? %;\
       /break %;\
    /endif %;\
   /if /mpTest %{1} <- %; /then /break %; /endif %;\
   /DoMove <-%{1} %;\
   /set mpCurLoc=%{mpDefLoc} %;\
   /set mpCurTrack= %;\

/mpDef2 PrintMove = \
   /set mpCurPath= %;\
   /mpEvalPath %{*} %;\
   /echo %{mpCurPath} %;\
   /unset mpCurPath

/mpDef2 DoMove = \
   /if /test "%{1}" =~ "-v" %; /then \
       /let NoGag=1 %;\
       /shift %;\
    /endif %;\
   /if /test "%{1}" =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /set mpCurPath= %;\
   /mpEvalPath %{*} %;\
   /mpGo %{mpCurPath} %;\
   /unset mpCurPath

/mpDef2 Where = \
   /if /test %{#} != 0 %; /then \
       /if /uMacroExist ->%{1} %; /then \
           /set mpCurLoc=%{1} %;\
           /set mpCurTrack= %;\
        /else \
           /mpecho Location %{1} unknown. %;\
       /endif %;\
    /endif %;\
   /mpecho Current location: %{mpCurLoc} %;\
   /if /test mpTrack =~ "on" %; /then \
       /mpecho Currect tracking: %{mpCurTrack} %;\
    /endif

/mpDef2 mpGag = \
   /if /test "%{1}" =~ "on" %; /then \
       /set mpGagDefault=1 %;\
    /endif %;\
   /if /test "%{1}" =~ "off" %; /then \
       /set mpGagDefault= %;\
    /endif %;\
   /if /test mpGagDefault %; /then \
       /mpecho Gagging is enabled. %;\
    /else \
       /mpecho Gagging disabled. %;\
    /endif

/mpDef2 mpPrecmd = /mpPrefix %{*}
/mpDef2 mpPrefix = \
   /set mpMovePrefix=%{*} %;\
   /mpecho Move Prefix set to: %{mpMovePrefix}

/mpDef2 mpPostcmd = /mpSuffix %{*}
/mpDef2 mpSuffix = \
   /set mpMoveSuffix=%{*} %;\
   /mpecho Move Suffix set to: %{mpMoveSuffix}

/mpDef2 mpSet = /mpStats
/mpDef2 mpStats = \
   /mpecho Move Prefix set to: %{mpMovePrefix} %;\
   /mpecho Move Suffix set to: %{mpMoveSuffix} %;\
   /mpecho Current Location: %{mpCurLoc}

; Internal macros

/mpDef2 mpGo = \
   /let mpGoTemp= %;\
   /while ({#}) \
      /let mpNextCmd=$(/mpExpand %{1}) %;\
      /if /test mpNextCmd!~"" %; /then \
          /let mpGoTemp=$[strcat({mpGoTemp},{mpNextCmd},"\\10")] %;\
       /else \
          /let mpGoTemp=$[strcat({mpGoTemp},{1},"\\10")] %;\
       /endif %;\
      /shift %;\
   /done %;\
   /if (mpMovePrefix !~ "") \
       %{mpMovePrefix} %;\
    /endif %;\
   /if (!NoGag & (Gag | mpGagDefault)) \
       /uGag -s glance %{mpGoTemp} %;\
    /else \
       /eval %{mpGoTemp} %;\
    /endif %;\
   /if (mpMoveSuffix !~ "") \
       %{mpMoveSuffix} %;\
    /endif

/mpDef2 mpEvalPath = \
   /while /test %{#} %; /do \
       /let Prefix=$[substr({1},0,2)] %;\
       /if (Prefix =~ "->" | Prefix =~ "<-") \
               /let Loc=$[substr({1},2)] %;\
               /if /mpTest %{1} %; /then %;\
                   /set mpCurPath= %;\
                   /break %;\
                /endif %;\
               /eval /set mpTempPath=$${%{1}} %;\
               /if /test (mpTempPath =~ "expand" & Prefix =~ "<-") %; /then \
                   /purge -i -- %{1} %;\
                   /eval /mpDef %{1} = $$(/mpReverse $${->%{Loc}}) %;\
                   /eval /set mpTempPath=$${%{1}} %;\
                /endif %;\
               /mpEvalPath %{mpTempPath} %;\
               /shift %;\
       /elseif ({1} != 0) \
           /for i 1 %{1} /mpAddPath %{2} mpCurPath%;\
           /shift 2 %;\
        /else \
           /mpAddPath %{1} mpCurPath %;\
           /shift %;\
        /endif %;\
   /done %;\
   /unset mpTempPath

/mpDef2 mpAddPath = \
   /eval /set mpTempPath=%%{%{2}} %;\
   /let NewDir=%{1} %;\
   /let NewDirC=$(/mpCancel %{NewDir}) %;\
   /while /test 1 %; /do \
      /let LastDir=$(/clst %{mpTempPath}) %;\
      /let LastDirC=$(/mpCancel %{LastDir}) %;\
      /if /test LastDir =~ NewDirC & NewDirC !~ "" %; /then \
          /set %{2}=$(/nlst %{mpTempPath}) %;\
          /break %;\
       /endif %;\
      /if /test LastDirC !~ "-" & LastDirC !~ "" %; /then \
          /eval /set %{2}=%%{%{2}} %{NewDir} %;\
          /break %;\
       /endif %;\
      /set mpTempPath=$(/nlst %{mpTempPath}) %;\
      /if /test mpTempPath =~ "" %; /then \
          /eval /set %{2}=%%{%{2}} %{NewDir} %;\
          /break %;\
       /endif %;\
    /done      

/mpDef2 mpReverse = \
   /set mpRevPath= %;\
   /set mult= %;\
   /while /test %{#} %; /do \
      /let arg=%{1} %;\
      /let Prefix=$[substr(arg,0,2)] %;\
      /if /test Prefix =~ "->" %; /then \
          /eval /uPush <-$$[substr(arg,2)] mpRevPath %;\
          /set mult= %;\
       /elseif /test Prefix =~ "<-" %; /then \
          /eval /uPush ->$$[substr(arg,2)] mpRevPath %;\
          /set mult= %;\
       /elseif /test mp_%{1}!~"" %; /then \
          /set ReverseDir=$(/mpCancel %{1}) %;\
          /if /test ReverseDir !~ "-" %; /then \
              /uPush %{ReverseDir} mpRevPath %;\
           /else \
              /set mult= %;\
           /endif %;\
          /if /test mult > 0 %; /then \
              /uPush %{mult} mpRevPath %;\
              /set mult= %;\
           /endif %;\
       /elseif /test %{1} > 0 %; /then \
          /set mult=%{1} %;\
       /else \
          /uPush %{1} mpRevPath %;\
          /if /test mult > 0 %; /then \
              /uPush %{mult} mpRevPath %;\
              /set mult= %;\
           /endif %;\
       /endif %;\
      /shift %;\
    /done %;\
   /echo -- %{mpRevPath} %;\
   /unset mult %;\
   /unset mpRevPath

/mpDef2 mpTest = \
   /if /!uMacroExist %{2}%{1} %; /then \
       /mpecho Path %{2}%{1} not defined. %;\
    /endif %;\
   /!uMacroExist %{2}%{1}

/mpDef2 clst = /echo -- %L1
/mpDef2 nlst = /echo -- %-L1

; Tracking additions

/mpDef2 mpAddTrack = \
   /if /test mpCurTrack !~ "" %; /then \
       /set mpCurTrack=%{mpCurTrack} %{*} %;\
    /else \
       /set mpCurTrack=%{*} %;\
    /endif %;\
   /send %{*}

/mpDef2 mpTrack = \
   /if /test "%{1}" =~ "on" | "%{1}" =~ "off" %; /then \
       /set mpTrack=%{1} %;\
    /endif %;\
   /purge mpTrackHook %;\
   /if /test mpTrack =~ "on" %; /then \
       /def -p9999 -h'send {n|s|e|w|u|d|enter|out|nw|ne|sw|se}' mpTrackHook \
          = /mpAddTrack %%* %;\
    /endif %;\
   /mpecho Tracking %{mpTrack}.

/mpDef2 mpRecord = \
   /if /test mpCurLoc =~ "" %; /then \
       /mpecho Current location unknown! %;\
       /break %;\
    /endif %;\
   /if /test "%{1}" =~ "" %; /then \
       /mpecho Record under what location? %;\
       /break %;\
    /endif %;\
   /purge -- ->%{1} %;\
   /purge -- <-%{1} %;\
   /if /test mpCurLoc !~ mpDefLoc %; /then \
       /mpDef %{1} = ->%{mpCurLoc} %{mpCurTrack} %;\
    /else \
       /mpDef %{1} = %{mpCurTrack} %;\
    /endif

/mpDef2 mpMark = \
   /set mpMarkLoc%{1}=%{mpCurLoc} %;\
   /set mpMarkTrack%{1}=%{mpCurTrack}


/mpDef2 mpTranslatePath = \
        /mpEvalPath %{*} %;\
        /mpConcatPath %{mpCurPath} %;\
        /set mpCurPath= 

/mpDef2 mpConcatPath = \
        /set mpPath= %;\
        /while /test %{#} %; /do \
                /let mpNextCmd=$(/mpExpand %{1}) %;\
                /if /test mpNextCmd!~"" %; /then \
                        /set mpPath=$[strcat(mpPath,mpNextCmd,"\\10")] %;\
                /else \
                        /set mpPath=$[strcat(mpPath,{1},"\\10")] %;\
                /endif %;\
                /shift %;\
        /done %;\

; Convienence macros

/mpDef2 mpClear = \
   /purge -i -- ->* %;\
   /purge -i -- <-*

/mpDef2 mpLoad = \
   /mpClear %;\
   /load %{*}
   
;/def -h'SEND goto *' = /goto %{-1}
;/def -h'SEND to *' = /to %{-1}
;/def -h'SEND from *' = /from %{-1}

; Help

/mpDef2 mpHelp = \
   /mpecho %;\
   /mpecho Makepath.tf Help %;\
   /mpecho %;\
   /mpecho to Loc                - Moves you from %{mpDefLoc} to Loc. %;\
   /mpecho from Loc              - Moves you from Loc to %{mpDefLoc}. %;\
   /mpecho goto Loc (from Loc2)  - Moves you from current location to Loc. %;\
   /mpecho /domove path          - Works like /dopath only faster. %;\
   /mpecho /where (Loc)          - Shows you where makepath.tf thinks you are, %;\
   /mpecho .                       or sets your current location to Loc. %;\
   /mpecho %;\
   /mpecho /mpdef Loc = path     - Define a location. (Auto makes -> & <-) %;\
   /mpecho /mpdef ->Loc = path   - Define a to Loc macro. %;\
   /mpecho /mpdef <-Loc = path   - Definte a from Loc macro. %;\
   /mpecho /mpgag (on|off)       - Set default gagging on or off. %;\
   /mpecho %;\
   /mpecho Note path can be single directions (n, s, e), a repeated %;\
   /mpecho direction (4 n, 3 s), even to/from macros (->augustina, %;\
   /mpecho <-wynt). %;\
   /mpecho %;\
   /mpecho /to, /from, /goto, and /domove all accept a -g flag for only gagging %;\
   /mpecho a single movement. (ex. /to -g augustina) %;\
   /mpecho

; Quit macro

/mpDef2 mpQuit = \
   /mpClear %;\
   /for i $(/car %{makepath_res}) $(/cdr %{makepath_res}) /undefn %%{i} %;\
   /foreach mpAliases /unset %;\
   /mapcar /unset makepath_tf makepath_res mpAliases %;\
   /purge mpTrackHook %;\
   /echo % makepath.tf removed.

; At macro

/mpDef2 at = \
  /eval /goto %{1} %%; %{-1} %%; /goto %{mpCurLoc}

/eval /set makepath_res=%{makepath_res} %?

/mpecho Makepath.tf v2.7 ready.
/mpecho Questions, comments, criticisms to Symbolic.


; Overdrive

/mpDefLoc Cath

; Default aliases

/mpalias n s !n
/mpalias s n !s
/mpalias e w !e
/mpalias w e !w
/mpalias ne sw !ne
/mpalias sw ne !sw
/mpalias nw se !nw
/mpalias se nw !se
/mpalias u d !u
/mpalias d u !d
/mpalias enter out !enter
/mpalias out enter !out

