
;
; Prompt.tf
;
; Simple triggers and macros to keep track of current hp and sp, allow
; user definition of prompt, and to execute macros from a queue or on an
; each-prompt basis.  
;
; Mainly for use by other tf modules.
;
; Requires util.tf v0.8
;
; Questions, comments, criticisms to Symbolic.
;

/if /test util_tf < 8 %; /then \
    /echo % WARNING: util.tf v0.8 required for prompt.tf! %;\
 /endif

/set prompt_tf=13

/def -i pVer = /echo @(#) prompt.tf  v1.3  (10/25/96)

/eval /set prompt_res=%?

/def -i pDef = /def -i p%{*}

; Initialization

/pDef Reset = \
   /set PanicHP=0 %;\
   /purge Panic %;\
   /set promptQ= %;\
   /set promptEngaged=0

/pReset

; Main Trig

/def -i -ag -mregexp -t'^[ >]*(-=>)* *HP: ([0-9]*)/([0-9]*) *[A-Z]*: ([0-9]*)/([0-9]*) *(EXP: |)([0-9]*|)(/|)([0-9]*|) <=-' pTrig = \
   /set HP=%P2 %; /set MaxHP=%P3%; /set SP=%P4 %;/set MaxSP=%P5 %;\
   /set XP=%P7 %; /set LevXP=%P9 %;\
   /set promptEngaged=0 %;\
   /if /test XP %; /then \
     /pXPHook %;\
   /endif %;\
   /pPrompt %;\
   /if /test HP < PanicHP %; /then \
       /pecho *PANIC* ! %;\
       /uCallHook Panic %;\
    /endif %;\
   /pDoQ %;\
   /if /test "${pHooks}" !~ "" %; /then \
       /pHooks %;\
    /endif %;\
   /set promptQ=%{promptQ2} %{promptQ}

/pdef DoQ = \
   /set promptQ2=%{promptQ} %;\
   /set promptQ= %;\
   /while /test (promptQ2 !~ "" & promptEngaged==0) %; /do \
          /let action=$(/uGetQ promptQ2) %;\
          /eval /%{action} %;\
    /done

/pDef Send = \
   /set promptEngaged=1 %;\
   /send %{*}

; Prompt customization/display

/pDef SetPrompt = \
   /purge -i pPrompt %;\
   /pDef Prompt = /echo -- %{*}

/pDef ResetPrompt = \
   /pSetPrompt -=> HP: %%{HP}/%%{MaxHP}  SP: %%{SP}/%%{MaxSP} <=- %{tkTrackPrompt}

/pResetPrompt

; Queue util macros
;
; /pPutQ (action) - place action in queue & do next action if not engaged
; /pPriorityQ (action) - place action in front of queue &    ""     ""
; /pClearQ (action) - remove all instances of action from queue
; /pNextQ (action) - place action in queu to be executed next prompt

/pDef PutQ = \
   /if /test promptEngaged==0 %; /then \
       /eval /%{1} %;\
    /else \
       /set promptQ=%{promptQ} %{1} %;\
    /endif

/pDef PriorityQ = \
   /if /test promptEngaged==0 %; /then \
       /eval /%{action} %;\
    /else \
       /set promptQ=%{1} %{promptQ} %;\
    /endif

/pDef NextQ = \
   /set promptQ=%{promptQ} %{1} %;\

/pDef ClearQ = \
   /eval /set promptQ=$$(/remove %{1} %{promptQ})
   
; Hook macros

/pDef Hook = \
   /if /test "%{1}" !~ "" %; /then \
       /eval /set promptHooks=%{1} $$(/remove %{1} %{promptHooks}) %;\
       /pEvalHooks %;\
    /else \
       /pEcho Current hooks: %;\
       /pEcho %{promptHooks} %;\
    /endif
   
/pDef UnHook = \
   /eval /set promptHooks=$$(/remove %{1} %{promptHooks}) %;\
   /pEvalHooks

/pDef EvalHooks = \
   /purge -i pHooks %;\
   /def pHooks %;\
   /foreach promptHooks /pAddHook

/pDef AddHook = \
   /eval /purge -i pHooks %%; /def pHooks = /%{1} %%%; ${pHooks}

; Panic Function

/pDef SetPanic = \
   /if /test %# %; /then \
       /if /test "%{1}" > 0 %; /then \
           /set PanicHP=%{1} %;\
           /shift %;\
        /else \
           /if /test "%{1}" =~ "off" | "%{1}" =~ "0" %; /then \
               /set PanicHP=0 %;\
               /shift %;\
            /endif %;\
        /endif %;\
       /if /test "%{*}" !~ "" %; /then \
           /purge Panic %;\
           /def Panic = %{*} %;\
        /endif %;\
    /endif %;\
   /if /test PanicHP %; /then \
       /pecho Panic at %{PanicHP} hp, command to execute: ${Panic} %;\
    /else \
       /pecho Panic off. %;\
    /endif

; Echo macros

/pDef Echo = \
   /echo -aB ! %{*}

; Quit macro

/pDef Quit = \
   /for i $(/car %{prompt_res}) $(/cdr %{prompt_res}) /undefn %%{i} %;\
   /purge -i Panic %;\
   /purge -i pHooks %;\
   /mapcar /unset prompt_tf prompt_res HP SP PanicHP promptQ \
                  promptHooks promptEngaged %;\
   /echo % prompt.tf removed.

/eval /set prompt_res=%{prompt_res} %?

; Hooks

/def Panic
/def pHooks
/pDef XPHook

/pReset

