; 2/20/03 - Updated by Nightshade
; 10/16/95 - Clepto
; Clepto's Guide to Overdrive and Symbolics mp.dirs

; This file is intended to give a summary of the various locations
; presented in Symbolic's mp.dirs file.  With this file, you won't
; have to /sh less mp.dirs anymore.  Just type /dirs and it will give
; you a list of the various areas available.  do /<area> and it will
; give you the specific /goto name for use with Symbolic's mp.dirs
; file.  Enjoy! =) 8) -clepper

; NOTE: a couple of directions have been modified on my part, so some 
; of the ones included here may not exist in Symbolic's mp.dirs
; NOTE2: Since I'm not a wimpy mage ;)  Several of my directions
; actually place me in the room with the monsters where Symbolic's
; directions place him just outside the room.  Please take this into
; account.

/echo -aB ## Path List loaded.
/echo -aB ## Type "/dirs" to look up path names.
 
/def -i dirs = \
  /if ({#} > 0) \
    /eval /mp_%{1} %;\
  /else \
        /echo -aB Path Guide %;\
	/echo The following directions are available: %;\
	/echo %;\
	/echo -aCgreen cath : Farcaern Cathedral %;\
	/echo -aBCcyan |city|        |alesia|      |traispek|   |gutmar| %;\
	/echo -aBCcyan |tomak|       |ordenk|      |alk|        |viking| %;\
	/echo -aBCcyan |maldicee|    |ironspike|   |kren|       |druegar| %;\
	/echo -aBCcyan |bandu|       |gplains|     |mplains|    |nwplains| %;\
	/echo -aBCcyan |lasforest|   |midian|      |iplains|    |nw| %;\
	/echo -aBCcyan |ocean|       |fog|         |swamp|      |grym| %;\
	/echo -aBCcyan |dforest|     |fair|        |zoo|        |acurion| %;\
	/echo -aBCcyan |marsh|       |boards|      |training|   |gates| %;\
	/echo -aBCcyan |oorts|       |hell|                               %;\
       /echo %;\
	/echo For use with /goto /to /from /g /at %;\
	/echo Expand listings denoted by |loc| by typing /dirs loc %;\
	/echo e.g. /dirs druegar to see druegar paths %;\
  /endif

; Gates
/def -i mp_gates = \
	/echo -aB CIRCLE OF ANCIENT STONES %;\
	/echo -aCgreen alkgate : Alkaziel Gate %;\
	/echo -aCgreen malgate : Maldicee Gate %;\
	/echo -aCgreen gutgate : Gutmar Gate %;\
	/echo -aCgreen tomgate : Tomak Gate %;\
	/echo -aCgreen lasgate : Lasarian's Fortress Gate %;\
	/echo -aCgreen somgate : Port Somias Gate %;\
	/echo -aCgreen opgate  : Operatus Gate

; Marshes
/def -i mp_marsh = \
	/echo -aB INLAND MARSH %;\
	/echo -aCgreen marsh  : Entering the Inland Marsh %;\
	/echo -aCgreen kordyn : Kordyn %;\
	/echo -aCgreen turtle : A Giant Painted Turtle %;\

; Oorts
/def -i mp_oorts = \
       /echo -aCgreen oorts : Oorts Camp %;\

; Hell
/def -1 mp_hell = \
       /echo -aCgreen hell : To Charon the Ferryman

; Discussion Boards
/def -i mp_boards = \
	/echo -aB DISCUSSION BOARDS %;\
	/echo -aCgreen main    : Main Boards (also w & e) %;\
	/echo -aCgreen tormal  : Tormal's Board %;\
	/echo -aCgreen balance : Balance Board %;\
	/echo -aCgreen war     : Party Wars Board %;\
	/echo -aCgreen duel    : Duelist's Board %;\
	/echo -aCgreen poetry  : Poetry Board %;\
	/echo -aCgreen scary   : Scary Board %;\
	/echo -aCgreen flame   : Flame Board %;\
	/echo -aCgreen mbrds   : Mage Boards (mages only) %;\
	/echo -aCgreen pbrds   : Priest Boards (priest only) %;\
	/echo -aCgreen tbrds   : Thief Boards (thieve only)

; Acurion Tower Locations
/def -i mp_acurion = \
	/echo -aB ACURION TOWER LOCATIONS %;\
	/echo -aCgreen spec0  : By Northwest Road %;\
	/echo -aCgreen spec1  : In a Maze of Fog %;\
	/echo -aCgreen spec2  : (Nonexistent) %;\
	/echo -aCgreen spec3  : In a Fetid Swamp %;\
	/echo -aCgreen spec4  : In the Northeast %;\
	/echo -aCgreen spec5  : In a Wood %;\
	/echo -aCgreen spec6  : Near the Rocky Mountain %;\
	/echo -aCgreen spec7  : In a Peaceful Forest %;\
	/echo -aCgreen spec8  : On some High Plains %;\
	/echo -aCgreen spec9  : In the Mountains %;\
	/echo -aCgreen spec10 : Deep in the Mountains of Madness %;\
	/echo -aCgreen spec11 : In an Evil Forest

; Training
/def -i mp_training = \
	/echo -aB TRAINING LOCATIONS %;\
	/echo -aBCcyan |stats|  : Stats %;\
	/echo -aBCcyan |skills| : Skills %;\
	/echo -aBCcyan |ftrain| : Fighter Skills & Talents %;\
	/echo -aBCcyan |mtrain| : Mage Skills & Spells %;\
	/echo -aBCcyan |ptrain| : Priest Skills & Gifts %;\
	/echo -aBCcyan |ttrain| : Thief Talents & Items

; Stat Training
/def -i mp_stats = \
	/echo -aB STATS TRAINING %;\
	/echo -aCgreen str : Strength %;\
	/echo -aCgreen int : Intelligence %;\
	/echo -aCgreen wis : Wisdom %;\
	/echo -aCgreen dex : Dexterity %;\
	/echo -aCgreen con : Constitution

; Skills Training
/def -i mp_skills = \
	/echo -aB SKILLS TRAINING %;\
	/echo -aCgreen att    : Attack %;\
	/echo -aCgreen def    : Defense %;\
	/echo -aCgreen crit   : Critical %;\
	/echo -aCgreen resist : Resistance %;\
	/echo -aCgreen climb  : Climbing %;\
	/echo -aCgreen search : Searching %;\
	/echo -aCgreen swim   : Swimming %;\
	/echo -aCgreen perc   : Perception (search for Phil) %;\
	/echo -aCgreen weap   : Weapons & Two-Handed %;\
	/echo -aCgreen zero   : Weapons Skill Zeroer

; Fighter Skills Training
/def -i mp_ftrain = \
	/echo -aB FIGHTER TRAINING %;\
	/echo -aCgreen bash    : Bash %;\
	/echo -aCgreen punch   : Punch %;\
	/echo -aCgreen parry   : Parry %;\
	/echo -aCgreen mult    : Multiple %;\
	/echo -aCgreen dodge   : Dodge %;\
	/echo -aCgreen unarmed : Unarmed %;\
	/echo -aCgreen whirl   : Whirl %;\
	/echo -aCgreen berserk : Berserk %;\
	/echo -aCgreen charge  : CHARGE!

; Mage Skills Training
/def -i mp_mtrain = \
	/echo -aB MAGE TRAINING %;\
	/echo -aCgreen evoc   : Evocation %;\
	/echo -aCgreen cont   : Continuance %;\
	/echo -aCgreen elem   : Elements %;\
	/echo -aCgreen illu   : Illusion %;\
	/echo -aCgreen proj   : Projection %;\
	/echo -aCgreen aug    : Augury %;\
	/echo -aCgreen ench   : Enchantment %;\
	/echo -aCgreen manif  : Manifestation %;\
	/echo -aCgreen dis    : Disassociation %;\
	/echo -aCgreen spells : Spells

; Priest Skills Training
/def -i mp_ptrain = \
	/echo -aB PRIEST TRAINING %;\
	/echo -aCgreen pmanif : Manifestation %;\
	/echo -aCgreen pench  : Enchantment %;\
	/echo -aCgreen pwll   : Will %;\
	/echo -aCgreen pchn   : Channeling %;\
	/echo -aCgreen pcom   : Commune %;\
	/echo -aCgreen pcrs   : Curse %;\
	/echo -aCgreen pdiv   : Divinity %;\
	/echo -aCgreen pbls   : Blessing %;\
	/echo -aCgreen pnat   : Nature %;\
	/echo -aCgreen pgift  : Gifts

/def -i mp_ttrain = \
	/echo -aB THIEF TRAINING & GOODIES %;\
	/echo -aCgreen hester : Talents %;\
	/echo -aCgreen asx    : Poison Shop %;\
	/echo -aCgreen bomb   : Bomb Shop

; Farcaern
/def -i mp_city = \
	/echo -aB THE CITY OF FARCAERN %;\
	/echo -aBCcyan |fighterq|  : Fighter Quarters %;\
	/echo -aBCcyan |mageq|     : Mage Quarters %;\
	/echo -aBCcyan |priestq|   : Priest Quarters %;\
	/echo -aBCcyan |thiefq|    : Thief Quarters %;\
	/echo -aBCcyan |outskirts| : City Outskirts %;\
	/echo -aCgreen tree        : Way up in an Old Oak Tree %;\
	/echo -aCgreen stone       : A cobblestone! %;\
	/echo -aCgreen wall1       : East Tower Cellar %;\
	/echo -aCgreen wall2       : South Tower Cellar %;\
	/echo -aCgreen wall3       : West Tower Cellar %;\
	/echo -aCgreen wall4       : North Tower Cellar %;\
	/echo -aCgreen twalls      : City Walls (shield location)

; Fighter Quarters
/def -i mp_fighterq = \
	/echo -aB THE CITY OF FARCAERN - FIGHTER QUARTERS %;\
	/echo -aBCcyan |prae|    : Praesidium %;\
	/echo -aCgreen bank      : Lasarian Bank %;\
	/echo -aCgreen arena     : Arena of Death %;\
	/echo -aCgreen courtyard : Training Courtyard %;\
	/echo -aCgreen rope      : Shaw's Adventure Hardware Shop %;\
	/echo -aCgreen santeli   : Santeli, the Fencing Master (w) (wand location) %;\
	/echo -aCgreen wynt      : Statue of Wynt %;\
	/echo -aCgreen atrium    : Fighter Citadel Atrium %;\
	/echo -aCgreen fvault    : Fighter Vault

; Mage Quarters
/def -i mp_mageq = \
	/echo -aB THE CITY OF FARCAERN - MAGE QUARTERS %;\
	/echo -aCgreen body     : The Body Shoppe %;\
	/echo -aCgreen bonk     : Carnival %;\
	/echo -aCgreen cait     : Cait Theatre %;\
	/echo -aCgreen frobs    : Frobozio's Haunted House %;\
	/echo -aCgreen gag      : Ye Olde Gagge Shoppe %;\
	/echo -aCgreen tax      : Herr Kalbfleisch's Taxidermy Shop %;\
	/echo -aCgreen lib      : Library of Farcaern %;\
	/echo -aCgreen maceiran : House of the MacEirans %;\
	/echo -aCgreen magic    : Magic Emporium %;\
	/echo -aCgreen mail     : Farcaern Postal Office %;\
	/echo -aCgreen meat     : Meatery Eatery %;\
	/echo -aCgreen sam      : Samuel %;\
	/echo -aCgreen weed     : Clump of Spenseweed! %;\
	/echo -aCgreen tripper  : Tripper Smail's Antique Shop %;\
	/echo -aCgreen mgld     : Mage Tower %;\
	/echo -aCgreen mvault   : Mage Vault %;\
;	/echo -aCgreen ink      : ?? %;\
;	/echo -aCgreen ladder   : ??

; Priest Quarters
/def -i mp_priestq = \
	/echo -aB THE CITY OF FARCAERN - PRIEST QUARTERS %;\
	/echo -aBCcyan |convent| : Abandoned Convent %;\
	/echo -aBCcyan |bard|    : Bardic Hall %;\
	/echo -aCgreen booth     : Donations Booth %;\
	/echo -aCgreen cbank     : Class Money Bank %;\
	/echo -aCgreen ribbon    : A Ribbon! %;\
	/echo -aCgreen tailor    : Lingham's Tailoring Shop %;\
	/echo -aCgreen drinks    : Monastery of St. Bouselaut %;\
	/echo -aCgreen herb      : Healin' Herb (n) %;\
	/echo -aCgreen ghouse    : Priests' Greenhouse (stones) %;\
	/echo -aCgreen relics    : Relic Shop %;\
	/echo -aCgreen pgld      : Priest Guild %;\
	/echo -aCgreen pvault    : Priest Vault

; Thief Quarters
/def -i mp_thiefq = \
	/echo -aB THE CITY OF FARCAERN - THIEF QUARTERS %;\
	/echo -aCgreen brew    : Dardian Brewery %;\
	/echo -aCgreen lottery : Lottery Booth %;\
	/echo -aCgreen macs    : MacTavish's Shop %;\
	/echo -aCgreen mag     : Magnolia Tree %;\
	/echo -aCgreen pub     : The Laughing Swede Pub %;\
        /echo -aCgreen basil   : Basil's Sweet Shop %;\
        /echo -aCgreen jubian  : Jubian's Pawn Shop %;\
	/echo -aCgreen fire    : Fire Tower %;\
	/echo -aCgreen slums   : Abandoned Building (shield location) %;\
	/echo -aCgreen tvault  : Thief Vault

; Outskirts
/def -i mp_outskirts = \
	/echo -aB THE CITY OF FARCAERN - OUTSKIRTS, SEWERS %;\
	/echo -aBCcyan |maze|  : Maze of Death %;\
	/echo -aBCcyan |abyss| : Abyss of Evil %;\
	/echo -aBCcyan |grave| : Farcaern Cemetary %;\
	/echo -aCgreen obs     : Farcaern Observatory %;\
	/echo -aCgreen khif    : Khifayl the Astute (Observatory) %;\
	/echo -aCgreen monks   : Fanatical Monks (d) %;\
	/echo -aCgreen bud     : Newbie Gardens %;\
	/echo -aCgreen gallows : Farcaern's Gallows %;\
	/echo -aCgreen kela    : Home of Kela the Enchantress %;\
	/echo -aCgreen pond    : Newbie Pond %;\
	/echo -aCgreen rocky   : Newbie Mountain %;\
	/echo -aCgreen smoke   : Old Smokehouse %;\
	/echo -aCgreen kortal  : Newbie Forest %;\
	/echo -aCgreen kt      : Kortal Tree %;\
	/echo -aCgreen gar     : Lone Woodsman %;\
	/echo -aCgreen undead  : Newbie Ruins %;\
	/echo -aCgreen fissure : Fissure Entrance %;\
	/echo -aCgreen fr      : Eerie Dirt Mound %;\
	/echo -aCgreen mess    : Tree Hideout %;\
	/echo -aCgreen sfount  : Fountain in Hideout %;\
	/echo -aCgreen mtn     : Before a Mountain Range %;\
	/echo -aCgreen drift1  : Snow Drift (snowballs!) %;\
	/echo -aCgreen drift2  : Another Snow Drift (snowballs!) %;\
	/echo -aCgreen drift3  : And Another! (snowballs!!!) %;\
	/echo -aCgreen icaves  : Ice Caves (shield location) %;\
	/echo -aCgreen kibo    : Kibo Village %;\
	/echo -aCgreen helen   : Helen's Elixer Shoppe %;\
	/echo -aCgreen temple  : Ancient Temple in Sewers %;\
	/echo -aCgreen smug    : Smuggler's Warehouse

; Praesidium
/def -i mp_prae = \
	/echo -aB THE PRAESIDIUM %;\
	/echo -aCgreen prae      : Praesidium Courtyard %;\
	/echo -aCgreen augustina : Captain Augustina (s) %;\
	/echo -aCgreen gareth    : Gareth the Knight (w) %;\
	/echo -aCgreen well      : Praesidium Well %;\
	/echo -aCgreen marigus   : Marigus the Master Fletcher %;\
	/echo -aCgreen cellar    : Praesidium's Cellar %;\
	/echo -aCgreen jail      : Praesidium's Jail %;\
	/echo -aCgreen roof      : Roof of Stables

; Abandoned Convent
/def -i mp_convent = \
	/echo -aB ABANDONED CONVENT %;\
	/echo -aCgreen convent  : Convent Entrance %;\
	/echo -aCgreen cutter   : Stone-Cutter (stones) %;\
	/echo -aCgreen sister   : Sister Infirmerar %;\
	/echo -aCgreen stable   : Outside the Stables %;\
	/echo -aCgreen hshoe    : Convent Stables %;\
	/echo -aCgreen statue   : Convent Garden %;\
	/echo -aCgreen footpath : Narrow Footpath %;\
	/echo -aCgreen krakva   : Krakva (w) %;\
	/echo -aCgreen vine     : Vine-covered Wall %;\
	/echo -aCgreen cstone   : Abandoned Chapel (stones) %;\
	/echo -aCgreen bal      : Atop a Balcony

; Bardic Hall
/def -i mp_bard = \
	/echo -aB FARCAERN BARDIC HALL %;\
	/echo -aCgreen bard    : Bardic Hall Entrance %;\
	/echo -aCgreen bmaster : Hallway of the Bardic Masters %;\
	/echo -aCgreen bchest  : Rafters of the Gazebo

; Maze of Death
/def -i mp_maze = \
	/echo -aB MAZE OF DEATH %;\
	/echo -aCgreen aidyl         : Aidyl the Dwarven Forgemaster %;\
	/echo -aCgreen aidylguardian : Guardian of Power %;\
	/echo -aCgreen mazes         : A Room in the Maze of Death

; Abyss
/def -i mp_abyss = \
	/echo -aB ABYSS OF EVIL %;\
	/echo -aCgreen abyss  : Gateway to the Abyss of Evil %;\
	/echo -aCgreen lever  : Lever on the Elemental Plane %;\
	/echo -aCgreen plant  : Plant Blocking Way on Unholy Plane %;\
	/echo -aCgreen button : Button on the Unholy Plane

; Graveyard
/def -i mp_grave = \
	/echo -aB FARCAERN GRAVEYARD %;\
	/echo -aCgreen grave : Inside the Graveyard %;\
	/echo -aCgreen thug  : Secret Path to Smuggler's Warehouse %;\
	/echo -aCgreen tomb  : Entrance to the Tomb

; Grassy Plains
/def -i mp_gplains = \
	/echo -aB GRASSY PLAINS %;\
	/echo -aCgreen grassy : Start of grassy plains %;\
	/echo -aCgreen uni    : A Beautiful Unicorn (n) %;\
	/echo -aCgreen bobil  : Bobil's Hut %;\
	/echo -aCgreen sheep  : Just Outside the MacEiran Pastures

; Alesia
/def -i mp_alesia = \
	/echo -aB TOWN OF ALESIA %;\
	/echo -aCgreen alesia    : Streets of Alesia %;\
	/echo -aCgreen rochel    : Rochel (2 w) %;\
	/echo -aCgreen school    : Alesian School House %;\
	/echo -aCgreen theater   : Fluffy Sheep Theater %;\
	/echo -aCgreen kaard     : Kaard's Old Shack %;\
	/echo -aCgreen baker     : Matthew Wheatendon's Bakery %;\
	/echo -aCgreen mage      : Nafbiz Talenor's Magic Shop %;\
	/echo -aCgreen carpenter : Carpentry Shop %;\
	/echo -aCgreen smithy    : Alesian Smithy %;\
	/echo -aCgreen moira     : Moira Deneuve %;\
	/echo -aCgreen allycis   : Allycis of the Alesian Lake %;\
	/echo -aCgreen hermitage : Where Henry and Moira Meet

; Midian Forest
/def -i mp_midian = \
	/echo -aB MIDIAN FOREST %;\
	/echo -aCgreen midian   : Southern Edge of Midian Forest %;\
	/echo -aCgreen griffin  : A Griffin %;\
	/echo -aCgreen methrin  : Methrin's Manor%;\
	/echo -aCgreen gruesly  : Gruesly Greataxe (s sw e) %;\
	/echo -aCgreen chim     : The Chimaera %;\
	/echo -aCgreen helia    : Helia's House %;\
	/echo -aCgreen closet   : Guest Bedroom Closet %;\
	/echo -aCgreen incloset : Inside the Closet (wand location) %;\
	/echo -aCgreen doombull : Doombull's Cave %;\
	/echo -aCgreen oog      : Oog's Oak Tree %;\
	/echo -aCgreen oogmeat  : Tree with Rancid Meat %;\
	/echo -aCgreen grim     : Grimzolda the Putrid

; Mage Plains
/def -i mp_mplains = \
	/echo -aB MAGE PLAINS %;\
	/echo -aCgreen mplains  : Middle of the Mage Plains %;\
	/echo -aBCcyan |rtower| : Red Tower %;\
	/echo -aCgreen black    : Black Tower %;\
	/echo -aCgreen beast    : Your friend, and mine, Rusty (closed) %;\
	/echo -aCgreen shrine   : Shrine of the Mechanical Beast %;\
	/echo -aCgreen balairis : Balairis the Bard

; Red Tower
/def -i mp_rtower = \
	/echo -aB RED TOWER %;\
	/echo -aCgreen red      : Outside the Red Tower %;\
	/echo -aCgreen rtower   : Inside the Red Tower %;\
	/echo -aCgreen master   : Master of the Barracks (s) %;\
	/echo -aCgreen gateron  : Gateron the Instructor (s) %;\
	/echo -aCgreen ogateron : Gateron the Instructor  (2 s) %;\
	/echo -aCgreen gong     : Gongaladar the Red Magelord (s) %;\
	/echo -aCgreen study    : An Abandoned Study %;\
	/echo -aCgreen kaibab   : Kaibab the Stoneskin Trainer

; Ironspike
/def -i mp_ironspike = \
	/echo -aB DWARVEN KINGDOM OF IRONSPIKE%; \
	/echo -aCgreen irons   : Inside Ironspike Keep %;\
	/echo -aCgreen thurfin : Thurfin's Tower %;\
	/echo -aCgreen mines   : Mines Entrance %;\
	/echo -aCgreen haze1   : Haze Spawn Site 1 %;\
	/echo -aCgreen haze2   : Haze Spawn Site 2 %;\
	/echo -aCgreen haze3   : Haze Spawn Site 3 %;\
	/echo -aCgreen haze4   : Haze Spawn Site 4 %;\
	/echo -aCgreen haze5   : Haze Spawn Site 5 %;\
	/echo -aCgreen cloud   : A Cloud Giant %;\
	/echo -aCgreen disp    : Above the Displacer Beast %;\
	/echo -aCgreen dwarf1  : Dwarf Spawn Site 1 %;\
	/echo -aCgreen dwarf2  : Dwarf Spawn Site 2 %;\
	/echo -aCgreen dwarf3  : Dwarf Spawn Site 3 %;\
	/echo -aCgreen dwarf4  : Dwarf Spawn Site 4 %;\
	/echo -aCgreen dwarf5  : Dwarf Spawn Site 5 %;\
	/echo -aCgreen dwarf6  : Dwarf Spawn Site 6

; Kren
/def -i mp_kren = \
	/echo -aB THE KREN VILLAGE AND FORTRESS %;\
	/echo -aCgreen kren      : Kren Village Center %;\
	/echo -aCgreen kshop     : Kren Village Tradingpost %;\
	/echo -aCgreen kente     : Kente's Kren Pub %;\
	/echo -aCgreen krenwin   : 4 Kren Warriors %;\
	/echo -aCgreen krenw     : 4 Kren Warriors (n) %;\
	/echo -aCgreen krenw2in  : 2 Kren Warriors %;\
	/echo -aCgreen krenw2    : 2 Kren Warriors (ne) %;\
	/echo -aCgreen krencourt : Kren Hero Courtyard %;\
	/echo -aCgreen fort      : Kren Fortress Central Hall %;\
	/echo -aCgreen honor     : 3 Honor Guards (n) %;\
	/echo -aCgreen hero      : Hero Hall %;\
	/echo -aCgreen antor     : Antor the Accomplished %;\
	/echo -aCgreen mengar    : Mengar the Magnificent %;\
	/echo -aCgreen selbek    : Selbek the Supreme %;\
	/echo -aCgreen hoffnik   : Hoffnik the Horror %;\
	/echo -aCgreen findarr   : Findarr the Weapons Trainer (e n e) %;\
	/echo -aCgreen slickhawk : Slickhawk the Kren Agent %;\
	/echo -aCgreen tenar     : Tenar the Wise (2 u) %;\
	/echo -aCgreen klek      : Klek the Kren Master (2 d) %;\
	/echo -aCgreen snakepit  : Fortress Snakepit

; Ice Plains
/def -i mp_iplains = \
	/echo -aB ICE PLAINS %;\
	/echo -aCgreen ice     : Southeast Edge of Ice Plains %;\
	/echo -aCgreen ice1    : Somewhere in Ice Plains %;\
	/echo -aCgreen yeti    : Yeti (n) %;\
	/echo -aCgreen yeti2   : Yeti (e) %;\
	/echo -aCgreen abinar  : Abinar (n) %;\
	/echo -aCgreen zentar  : Zentar the Ice Trainer (n) %;\
	/echo -aCgreen barb    : Barbarian Campsite %;\
	/echo -aBCcyan |icec|  : Ice Caves

; Ice Caves
/def -i mp_icec = \
	/echo -aB ICE CAVE %;\
	/echo -aCgreen icec     : Entrance to the Ice Caves %;\
	/echo -aCgreen vesp1    : Vespa Beetle %;\
	/echo -aCgreen vesp2    : Vespa Beetle %;\
	/echo -aCgreen vesp3    : Vespa Beetle %;\
	/echo -aCgreen hargan   : Hargan the Scourge (n) %;\
	/echo -aCgreen tritiok  : Tritiok the Kren Ranger (n) %;\
	/echo -aCgreen streker  : Streker (n e) %;\
	/echo -aCgreen labifat  : Labifat %;\
	/echo -aCgreen olabifat : Labifat (e) %;\
	/echo -aCgreen ivfat    : Ivfat (n) %;\
	/echo -aCgreen manix    : Manix (e)

; Las Forest
/def -i mp_lasforest = \
	/echo -aB LASARIAN'S FOREST, ELF FOREST, AND ELVEN ARCHERY SCHOOL %;\
	/echo -aCgreen lasforest : Edge of Lasarian's Forest %; \
	/echo -aCgreen goose     : A Fat Goose by a Waterfall %;\
	/echo -aCgreen mummy     : A Mummy (n) %;\
	/echo -aCgreen hgiant    : A Hill Giant (n) %;\
	/echo -aCgreen root      : An Old Shack %;\
	/echo -aCgreen secor     : Outside Secor's House %;\
	/echo -aCgreen jonnis    : Jonnis (n) %;\
	/echo -aCgreen welf      : Wise Old Elf %;\
	/echo -aCgreen cave      : Goblin Cave %;\
	/echo -aCgreen guard     : Goblin Guards %;\
	/echo -aCgreen captain   : Goblin Captain %;\
	/echo -aCgreen lieut     : Goblin Lieutenant %;\
	/echo -aCgreen dragon    : Goblin King's Dragon (s) %;\
	/echo -aCgreen arch      : Elven Archery School %;\
	/echo -aCgreen bowmaster : Elven Bow Master (n)

; Druegar
/def -i mp_druegar = \
	/echo -aB DRUEGAR CAMP %;\
	/echo -aCgreen druegar : Center of the Druegar camp %;\
	/echo -aCgreen dshop   : Druegar Camp Armory %;\
	/echo -aCgreen sol1    : 3 Soldiers %;\
	/echo -aCgreen sol2    : 3 Soldiers %;\
	/echo -aCgreen sol3    : 3 Soldiers %;\
	/echo -aCgreen sol4    : 3 Soldiers %;\
	/echo -aCgreen sol5    : 3 Soldiers %;\
	/echo -aCgreen vet1    : 3 Veterans %;\
	/echo -aCgreen vet2    : 3 Veterans %;\
	/echo -aCgreen vet3    : 3 Veterans %;\
	/echo -aCgreen aide    : 2 Aide-de-Camps (w) %;\
	/echo -aCgreen milbre  : Freud Milbre (w) %;\
	/echo -aCgreen gunter  : Gunter Bonesplitter %;\
	/echo -aCgreen ogunter : Gunter Bonesplitter (nw) %;\
	/echo -aCgreen starn   : 3 Chargers Guarding Starn's Tent %;\
	/echo -aCgreen rotog   : Rotog the Solemn Warrior (w) %;\
	/echo -aCgreen floris  : Floris the Butcher (s) %;\
	/echo -aCgreen bedor   : Bedor the Engineer (n) %;\
	/echo -aCgreen milady  : Milady Jorrd (n)

; Fair
/def -i mp_fair = \
	/echo -aB TRAVELING FAIR %;\
	/echo -aCgreen fair      : Fair Entrance %;\
	/echo -aCgreen tasnim    : Tasnim the Divine %;\
	/echo -aCgreen musician  : Cheerful Musician %;\
	/echo -aCgreen omusician : Cheerful Musician (n) %;\
	/echo -aCgreen gideon    : Gideon Proprietor of the Fair (stones) %;\
	/echo -aCgreen gidio     : Gideon Proprietor of the Fair (e) %;\
	/echo -aCgreen gypsy     : A Wizened, Old Gypsy (n) %;\
	/echo -aCgreen igypsy    : A Wizened, Old Gypsy %;\
	/echo -aCgreen licoris   : Licoris the Giant Spider (n) %;\
	/echo -aCgreen hydra     : A Translucent Water Hydra (n) %;\
	/echo -aCgreen pets      : Animal Stalls %;\
	/echo -aCgreen pets2     : More Animal Stalls 

; Dark Forest
/def -i mp_dforest = \
	/echo -aB DARK FOREST %;\
	/echo -aCgreen dforest : Entrance to Dark Forest %;\
	/echo -aCgreen ravine  : Entrance to the Ravine (stones) %;\

; Traispek
/def -i mp_traispek = \
	/echo -aB THE CITY OF TRAISPEK %;\
	/echo -aCgreen trais   : Entrance to Traispek %;\
	/echo -aCgreen filraen : Filraen's Home (e) %;\
	/echo -aCgreen youth   : A Stealthy Youth (n) %;\
	/echo -aCgreen berael  : Berael's Home %;\
	/echo -aCgreen durok   : Durok the smith (n) %;\
	/echo -aCgreen tar     : Tar K'hesh (e) %;\
	/echo -aCgreen cassidy : Father Cassidy %;\
	/echo -aCgreen oriley  : O'Riley's Pub and Grill %;\
	/echo -aCgreen tower   : Under Northwest Tower (wand location)

; NW
/def -i mp_nw = \
	/echo -aB NW RIVER AND VICINITY %;\
	/echo -aCgreen nwroad   : Beginning of the NW Road %;\
	/echo -aCgreen nwworm   : Tiny Worm %;\
	/echo -aCgreen nwriver  : Start of the NW River %;\
	/echo -aCgreen scurvy   : Scurvy the Undead Pirate %;\
	/echo -aCgreen raven    : A Large Raven %;\
	/echo -aCgreen nwcave   : Northwest Caverns %;\
	/echo -aCgreen bog      : Northeastern Bog %;\
	/echo -aCgreen alcove   : Cavern Alcove %;\
	/echo -aCgreen smock    : Tnanta's Shack %;\
	/echo -aCgreen taugh    : Taugh's Chambers %;\
	/echo -aBCcyan |tempus| : Crypts of Tempus

; Crypts of Tempus
/def -i mp_tempus = \
	/echo -aB CRYPTS OF TEMPUS %;\
	/echo -aCgreen crypts  : Crypt Entrance %;\
	/echo -aCgreen ocrypts : Just outside the Crypts %;\
	/echo -aCgreen zanz    : Zanzariosis (s e) %;\
	/echo -aCgreen tempus  : Tempus the Lich (w n)

; Tomak
/def -i mp_tomak = \
	/echo -aB VILLAGE OF TOMAK AND VICINITY %;\
	/echo -aCgreen tomak     : Village of Tomak %;\
	/echo -aCgreen abbot     : A Stout Abbot %;\
	/echo -aCgreen ren       : Ren the Lively Mage (e) %;\
	/echo -aCgreen shaft     : Northwest Mines %;\
	/echo -aCgreen angus     : The Dungeon of Angus %;\
	/echo -aCgreen ogre      : An Ogre (Angus) %;\
	/echo -aCgreen fiend     : Pit Fiend's Lair (Angus) %;\
	/echo -aCgreen gwolf     : Tunnel to the Ghostly Wolf %;\
	/echo -aCgreen trap      : Chambers of the Ghostly Wolf %;\
	/echo -aCgreen foothills : Foothills of the Mountains of Madness %;\
	/echo -aCgreen cyclops   : A Gigantic Cyclops (n) %;\
	/echo -aCgreen unga      : Cave of Unga and Ooga (nw) %;\
	/echo -aCgreen mubarqual : Mubarqual (w) %;\
	/echo -aCgreen troll     : Ledge to the Troll Castle

; Grymwaldian Forest
/def -i mp_grym = \
	/echo -aB GRYMWALDIAN FOREST %;\
	/echo -aCgreen grym      : Bridge to Grymwald Forest %;\
	/echo -aBCcyan |orc|     : Orc Stronghold %;\
	/echo -aCgreen woody     : Kelly Kalbfleisch's Shack %;\
	/echo -aCgreen anna      : Annabelle's Chicken %;\
	/echo -aCgreen frog      : A Giant Grymwaldian Frog %;\
	/echo -aCgreen demon     : Demon Guardian (n) %;\
	/echo -aCgreen slice     : Merboch Raettamore's House (w) %;\
	/echo -aCgreen dewey     : Dewey Desmole's Home %;\
	/echo -aCgreen skymark   : Entrance to Skymark Elves' Forest %;\
	/echo -aCgreen waterfall : Waterfall (shield location (s)) %;\
	/echo -aCgreen wbridge   : Underneath a Bridge in the Forest %;\
	/echo -aCgreen shack     : An Old Shack %;\
	/echo -aCgreen valerian  : A Closed Door (closed) %;\
	/echo -aCgreen cliff     : Cliff Overlooking Quarry %;\
       /echo -aCgreen creaver   : Creaver Pyramid

; Orc Stronghold
/def -i mp_orc = \
	/echo -aB ORC STRONGHOLD %;\
	/echo -aCgreen orcs    : Before the Orcish Stronghold (e) %;\
	/echo -aCgreen oshaman : Orc Shaman (w)

; Bandu
/def -i mp_bandu = \
	/echo -aB BANDU %;\
	/echo -aCgreen bandu     : Under the Bandu tree %;\
	/echo -aCgreen oldman    : The Old Man, Where's That Ghost?! %;\
	/echo -aCgreen bobgar    : Bobgar the Devourer (s) %;\
	/echo -aCgreen gorta     : Mighty Gorta (n) %;\
	/echo -aCgreen zull      : Zull %;\
	/echo -aCgreen dummy     : Sanlei the Weapon Master %;\
	/echo -aCgreen chieftain : Bandu Chieftain %;\
	/echo -aCgreen otang     : Otang's Tree

; Zoo
/def -i mp_zoo = \
	/echo -aB SIR FLARDIN'S PARK %;\
	/echo -aCgreen zoo   : In the zoo %;\
	/echo -aCgreen gonzo : Gonzo the Gate Watcher (e) %;\
	/echo -aCgreen eleph : Mother and Baby Elephants %;\
	/echo -aCgreen tiger : White Tiger (s) %;\
	/echo -aCgreen gilda : Gilda the Zookeep (e)

; Viking village
/def -i mp_viking = \
	/echo -aB VIKING VILLAGE %;\
	/echo -aCgreen viking  : Viking Village %;\
	/echo -aCgreen vshop   : Viking Village Shop %;\
	/echo -aCgreen medman  : Wise, Old Medicine Man (w) %;\
	/echo -aCgreen vikhero : Old War Hero %;\
	/echo -aCgreen vt1     : A Nimble, Sneaky Thief %;\
	/echo -aCgreen vt2     : A Nimble, Sneaky Thief %;\
	/echo -aCgreen vt3     : A Nimble, Sneaky Thief %;\
	/echo -aCgreen farmer  : Farmer's Hut

; NW Plains
/def -i mp_nwplains = \
	/echo -aBCcyan |bug|     : Bug Lair %;\
	/echo -aBCcyan |lasfort| : Lasarian's Fortress %;\
	/echo -aCgreen mound     : Burial Mound %;\
	/echo -aCgreen corby     : Corby's Nest %;\
	/echo -aCgreen giants    : Giant %;\
	/echo -aCgreen giants2   : Fire, Stone, and Frost Giants

; Bug tunnels
/def -i mp_bug = \
	/echo -aB BUG LAIR %;\
	/echo -aCgreen bug     : Bug Lair Entrance %;\
	/echo -aCgreen agamem  : Agamem the Simply Shocking (e) %;\
	/echo -aCgreen spark   : Chest of Sparkling Bracers (w) %;\
	/echo -aCgreen octopus : A Large Octopus

; Las Fort
/def -i mp_lasfort = \
	/echo -aB LASARIAN'S FORTRESS %;\
	/echo -aCgreen lasfort  : Fortress Courtyard %;\
	/echo -aCgreen laspub   : Haunted Tavern Pub %;\
	/echo -aCgreen beholder : A Beholder (u e) %;\
	/echo -aCgreen knights  : 3 Black Knights (w) %;\
	/echo -aCgreen swine    : A Devil-Swine %;\
	/echo -aCgreen conjur   : Conjuring Chamber

; Maldicee
/def -i mp_maldicee = \
	/echo -aB MALDICEE VILLAGE AND VICINITY %;\
	/echo -aCgreen maldicee  : Northern Edge of Maldicee Village %;\
	/echo -aCgreen sailor    : A Large Sailor in a Dusty Room %;\
	/echo -aCgreen funhouse  : Madam Foo's Funhouse %;\
	/echo -aCgreen agrippina : Agripina (s) %;\
	/echo -aCgreen annubnia  : Annubnia (s) %;\
	/echo -aCgreen uvillage  : Under Maldicee Village (shield location) %;\
	/echo -aCgreen elf       : Elven Guard %;\
	/echo -aCgreen mwr       : Magician's House %;\
	/echo -aCgreen granny    : Home of Granny the Axe %;\
	/echo -aCgreen gan       : Gan the Bandit Guard %;\
	/echo -aCgreen bregard   : Path to Bregard's Mansion %;\
	/echo -aCgreen beach     : Honeymoon Beach %;\
	/echo -aCgreen bandit    : A Shifty Bandit %;\
	/echo -aCgreen ratak     : The Ghost of Ratak (wand location) %;\
	/echo -aCgreen lava      : Entrance to the Lava Caves (s) %;\
	/echo -aCgreen lyle      : Prince Lyle %;\
	/echo -aCgreen squid     : A Gigantic Squid (d) %;\
	/echo -aCgreen ship      : Aboard a Cargo Ship %;\
	/echo -aCgreen somias    : Port Somias %;\
	/echo -aCgreen pyr       : Before an Enormous Pyramid

; Fog Forest
/def -i mp_fog = \
	/echo -aB FOG FOREST %;\
	/echo -aCgreen zaloria : Zaloria the Blur Trainer %;\
	/echo -aCgreen versal  : Versal's Dwelling %;\
	/echo -aCgreen owl     : Large Tree with Owl %;\
	/echo -aCgreen vale    : Entrance to the Misty Vale %;\
	/echo -aCgreen twin    : Yourself %;\
	/echo -aCgreen fogc    : Inside the Fog Forest Cave (shield location)

; Ordenk
/def -i mp_ordenk = \
	/echo -aB ORDENK VILLAGE %;\
	/echo -aCgreen ov    : 2 Ordenk Guards %;\
	/echo -aCgreen ov2   : 2 Ordenk Guards (e) %;\
	/echo -aCgreen brain : A Giant Fish %;\
	/echo -aCgreen slar  : Cavern of the Slar Beast (d)

; Alkaizel
/def -i mp_alk = \
	/echo -aB ALKAIZEL %;\
	/echo -aCgreen alk        : Path to Alkaizel %;\
	/echo -aCgreen alk1       : Alkaizel Guard %;\
	/echo -aCgreen alk2       : Alkaizel Guard %;\
	/echo -aCgreen glass      : Alkaizel Glassblower Shop %;\
	/echo -aCgreen alkfighter : Alkaizel Combat Ground (n) %;\
	/echo -aCgreen fountain   : A Small Fountain %;\
	/echo -aCgreen oasis      : Desert Oasis

; Gutmar
/def -i mp_gutmar = \
	/echo -aB TOWN OF GUTMAR AND GUTMARIAN FOREST %;\
	/echo -aCgreen gutmar    : Inside Gutmar %;\
	/echo -aCgreen sheaf     : Golden Sheaf Pub %;\
	/echo -aCgreen krenten   : Krenten the Smith (w) %;\
	/echo -aCgreen glassware : Walther Quimp's Home %;\
	/echo -aCgreen nabfiz    : Chess Master's Tower %;\
	/echo -aCgreen church    : Gutmarian Church %;\
	/echo -aCgreen gutshield : Warehouse (shield location)

; Swamp
/def -i mp_swamp = \
	/echo -aB SWAMP %;\
	/echo -aCgreen kyrdra     : Kyrdra's Hut %;\
	/echo -aCgreen tarok      : Tarok of the 5th Circle %;\
	/echo -aCgreen trog       : Ancient Ziggurat %;\
	/echo -aCgreen trogpriest : Troglodyte Priest (s) %;\
	/echo -aCgreen hetman     : Village Hetman %;\
	/echo -aCgreen ralf       : Ralf the Bum %;\
	/echo -aCgreen liz        : Lizard man Stronghold %;\
	/echo -aCgreen lman       : A Small Lizard Man %;\
	/echo -aCgreen farmaz     : Farmaz Utikahl the Spiritdisease Trainer %;\
	/echo -aCgreen lpit       : Lord of the Pit (shield location) %;\
	/echo -aCgreen altar      : Ancient Altar

; Ocean
/def -i mp_ocean = \
	/echo -aB OCEAN AND SURROUNDINGS %;\
	/echo -aCgreen nymph   : Water Nymph Cave %;\
	/echo -aCgreen chest2  : Barque Ruins %;\
	/echo -aCgreen girbali : Cliff of Girbali %;\
	/echo -aCgreen reef    : Coral Reef %;\
	/echo -aCgreen wb      : Beautiful Blue Shell (d) %;\
	/echo -aCgreen dock    : A Content Fisherman %;\
	/echo -aCgreen merman  : Dicentrarchus the Insane (n) %;\
	/echo -aCgreen pirates : Beside a Pirate Ship (shield location) %;\
	/echo -aCgreen crabman : A Crabman at the Mouth of a Cave %;\
	/echo -aCgreen hope2   : Sealed Hope %;\
	/echo -aCgreen moss    : Glowing Moss! %;\
	/echo -aCgreen band    : Corpse of Belceiht %;\
	/echo -aCgreen crab    : A Huge Cave Crab
