;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Observatory Macros

/def -i push = d\10push bar\10u\10'clarify
/def -i pull = d\10pull bar\10u\10'clarify
/def -i raise = d\10pull pin\10raise tube\10push pin\10u\10'clarify
/def -i lower = d\10pull pin\10lower tube\10push pin\10u\10'clarify
/def -i zoomin = d\10push eyepiece\10u\10'clarify
/def -i zoomout = d\10pull eyepiece\10u\10'clarify

/def -i Obs_Reset = \
  /set Obs_Dir=-1 %;\
  /set Obs_Zoom=-1 %;\
  /set Obs_Angle=-1 %;\
  /set Obs_Target=-1 %;\
  /set Obs_Div=-1 %;\
  /set Obs_Div_Dir=0 %;\
  /set Obs_Div_Angle=0 %;\
  /set Obs_Div_Zoom=0 %;\
  /set Obs_Khz=-1 %;\
  /set Obs_Khz_Dir=0 %;\
  /set Obs_Khz_Angle=0 %;\
  /set Obs_Khz_Zoom=0 %;\
  /set Obs_Mya=-1 %;\
  /set Obs_Mya_Dir=0 %;\
  /set Obs_Mya_Angle=0 %;\
  /set Obs_Mya_Zoom=0 %;\
  /set Obs_Ric=-1 %;\
  /set Obs_Ric_Dir=0 %;\
  /set Obs_Ric_Angle=0 %;\
  /set Obs_Ric_Zoom=0 %;\
  /set Obs_Shn=-1 %;\
  /set Obs_Shn_Dir=0 %;\
  /set Obs_Shn_Angle=0 %;\
  /set Obs_Shn_Zoom=0 %;\
  /set Obs_Init=0 %;\
  /set Obs_Hunt=0 %;\
  /set Obs_GotoCheck=0 %;\
  /for i 0 23 /set Obs_Check%%{i} 0
  
/Obs_Reset

/def -i FindAll   = /obs_find all
/def -i Diveth    = /obs_find diveth
/def -i Kahzz     = /obs_find kahzz
/def -i Myatraa   = /obs_find myatraa
/def -i Rictus    = /obs_find rictus
/def -i Shengaweh = /obs_find shengaweh

/def -i Obs_Find = \
  /if ({#} > 0) \
    /set Obs_Target=%1 %;\
  /endif %;\
  /set Obs_Dir=-1 %;\
  /set Obs_Zoom=-1 %;\
  /Obs_Init

/def -i Obs_Find2 = \
  /if (Obs_Target =~ "diveth") \
    /if (Obs_Div == 1) \
      /set Obs_GDir %Obs_Div_Dir %;\
      /set Obs_GAng %Obs_Div_Angle %;\
      /set Obs_GZom %Obs_Div_Zoom %;\
      /obs_goto %; /return %;\
    /elseif (Obs_Div == 0) \
      /obs_notthere %;/return %;\
    /endif %;\
  /elseif (Obs_Target =~ "kahzz") \
    /if (Obs_Khz == 1) \
      /set Obs_GDir %Obs_Khz_Dir %;\
      /set Obs_GAng %Obs_Khz_Angle %;\
      /set Obs_GZom %Obs_Khz_Zoom %;\
      /obs_goto %; /return %;\
    /elseif (Obs_Khz == 0) \
      /obs_notthere %;/return %;\
    /endif %;\
  /elseif (Obs_Target =~ "myatraa") \
    /if (Obs_Mya == 1) \
      /set Obs_GDir %Obs_Mya_Dir %;\
      /set Obs_GAng %Obs_Mya_Angle %;\
      /set Obs_GZom %Obs_Mya_Zoom %;\
      /obs_goto %;/return %;\
    /elseif (Obs_Mya == 0) \
      /obs_notthere %;/return %;\
    /endif %;\
  /elseif (Obs_Target =~ "rictus") \
    /if (Obs_Ric==1) \
      /set Obs_GDir %Obs_Ric_Dir %;\
      /set Obs_GAng %Obs_Ric_Angle %;\
      /set Obs_GZom %Obs_Ric_Zoom %;\
      /obs_goto %;/return %;\
      /elseif (Obs_Ric==0) \
      /obs_notthere %;/return %;\
    /endif %;\
  /elseif (Obs_Target =~ "shengaweh") \
    /if (Obs_Shn == 1) \
      /set Obs_GDir %Obs_Shn_Dir %;\
      /set Obs_GAng %Obs_Shn_Angle %;\
      /set Obs_GZom %Obs_Shn_Zoom %;\
      /obs_goto %;/return %;\
    /elseif (Obs_Shn == 0) \
      /obs_notthere %;/return %;\
    /endif %;\
  /elseif (Obs_Target =~ "all") \
    /echo -aB * Searching all orientations %;\
  /else \
    /echo -aB * Unknown Target Specified %;\
    /echo -aB * Choices: diveth, kahzz, myatraa, rictus, shengaweh, all %;\
    /return %;\
  /endif %;\
  /set Obs_Tries=24 %;\
  /Obs_Hunt

/def -i Obs_Init = \
  /set Obs_Init=1 %;\
  /if (Obs_Zoom == -1) \
    d\10look at eyepiece %;\
  /elseif (Obs_Dir == -1) \
    d\10pull bar\10look at tube %;\
  /else \
    /set Obs_Init=0 %;\
    /Obs_Find2 %;\
  /endif

/def -i Obs_NotThere = \
  /echo -aB * Target %Obs_Target not here.

/def -i Obs_Goto = \
  d %;\
  /set Obs_Move $[Obs_GDir - Obs_Dir] %;\
  /if (Obs_Move < 0) \
    /set Obs_Move $[Obs_Move + 24] %;\
  /endif %;\
  /for i 1 %Obs_Move /Obs_Push %;\
  /set Obs_Move $[Obs_Angle - Obs_GAng] %;\
  /if (Obs_Move > 0) \
    /for i 1 %Obs_Move /Obs_Lower %;\
  /else \
    /set Obs_Move $[abs(Obs_Move)] %;\
    /for i 1 %Obs_Move /Obs_Raise %;\
  /endif %;\
  /set Obs_Move $[Obs_Zoom - Obs_GZom] %;\
  /if (Obs_Move > 0) \
    /for i 1 %Obs_Move /obs_zoomout %;\
  /else \
    /set Obs_Move $[abs(Obs_Move)] %;\
    /for i 1 %Obs_Move /obs_zoomin %;\
  /endif %;\
  /set Obs_GotoCheck=1 %;\
  u\10'clarify

/def -i Obs_Push = \
  push bar %;\
  /set Obs_Tries=$[Obs_Tries - 1] %;\
  /eval /set Obs_Dir=$[mod(Obs_Dir + 1, 24)]
/def -i Obs_Raise = \
  pull pin\10raise tube\10push pin %;\
  /set Obs_Angle $[Obs_Angle + 1]
/def -i Obs_Lower = \
  pull pin\10lower tube\10push pin %;\
  /set Obs_Angle $[Obs_Angle - 1]
/def -i Obs_ZoomIn = \
  push eyepiece %;\
  /set Obs_Zoom $[Obs_Zoom + 1]
/def -i Obs_ZoomOut = \
  pull eyepiece %;\
  /set Obs_Zoom $[Obs_Zoom - 1]

/def -i -mregexp -t'^[> ]*Approximately.*at a ([a-zA-Z ]*) angle, and points to the ([a-zA-z\-]*).' Obs_TubeSetting = \
  /if     ({P1} =~ "nearly level")   /set Obs_Angle=0 %;\
  /elseif ({P1} =~ "slight")         /set Obs_Angle=1 %;\
  /elseif ({P1} =~ "sharp")          /set Obs_Angle=2 %;\
  /elseif ({P1} =~ "steep")          /set Obs_Angle=3 %;\
  /elseif ({P1} =~ "nearly upright") /set Obs_Angle=4 %;\
  /elseif ({P1} =~ "upright")        /set Obs_Angle=5 %;\
  /endif %;\
  /if     ({P2} =~ "north")     /set Obs_Dir=0  %;\
  /elseif ({P2} =~ "northeast") /set Obs_Dir=3  %;\
  /elseif ({P2} =~ "east")      /set Obs_Dir=6  %;\
  /elseif ({P2} =~ "southeast") /set Obs_Dir=9  %;\
  /elseif ({P2} =~ "south")     /set Obs_Dir=12 %;\
  /elseif ({P2} =~ "southwest") /set Obs_Dir=15 %;\
  /elseif ({P2} =~ "west")      /set Obs_Dir=18 %;\
  /elseif ({P2} =~ "northwest") /set Obs_Dir=21 %;\
  /endif %;\
  /if (Obs_Init) /Obs_Init %;/endif

/def -i -mregexp -t'^[> ]*A metal eyepiece.*The eyepiece ([a-zA-Z ]*).$' \
  Obs_EyepieceSetting = \
  /if     ({P1} =~ "extends out quite far") /set Obs_Zoom=0 %;\
  /elseif ({P1} =~ "extends out a bit")     /set Obs_Zoom=1 %;\
  /elseif ({P1} =~ "is half visible")       /set Obs_Zoom=2 %;\
  /elseif ({P1} =~ "is partially visible")  /set Obs_Zoom=3 %;\
  /elseif ({P1} =~ "is barely visible")     /set Obs_Zoom=4 %;\
  /endif %;\
  /if (Obs_Init) /Obs_Init %;/endif

/def -i -mregexp -t'^[> ]*There is no eyepiece here.$' Obs_NoEyepiece = \
  /set Obs_Init 0 %;\
  /echo -aB * No eyepiece!

/def -i Obs_Hunt = \
  d %;\
  /set Obs_Hunt=1 %;\
  /eval /set Obs_Cur %%Obs_Check%Obs_Dir %;\
  /while (Obs_Cur == 1 & Obs_Tries > 0) \
    /obs_push %;\
    /eval /set Obs_Cur %%Obs_Check%Obs_Dir %;\
  /done %;\
  /if (Obs_Tries == 0) \
    /if (Obs_Target =~ "all") \
      /echo -aB * Exhaustive Search Complete! %;\
    /else \
      /Obs_NoTarget %;\
    /endif %;\
    /set Obs_Hunt=0 %;\
    u %;\
    /return %;\
  /endif %;\
  u\10'clarify

/def -i Obs_NoTarget = \
  /echo -aB * Could not find target: %Obs_Target %;\
  /if     (Obs_Target =~ "diveth")    /set Obs_Div=0 %;\
  /elseif (Obs_Target =~ "kahzz")     /set Obs_Khz=0 %;\
  /elseif (Obs_Target =~ "myatraa")   /set Obs_Mya=0 %;\
  /elseif (Obs_Target =~ "rictus")    /set Obs_Ric=0 %;\
  /elseif (Obs_Target =~ "shengaweh") /set Obs_Shn=0 %;\
  /endif

/def -ip10 -mregexp -t'^[> ]*Khifayl.*says:.*The tube isn\'t pointing in the \
  proper direction.$' Obs_Nothing = \
  /if (Obs_GotoCheck) \
    /Obs_NoTarget %;\
    /set Obs_GotoCheck=0 %;\
  /elseif (Obs_Hunt) \
    /eval /set Obs_Check%Obs_Dir 1 %;\
    /obs_hunt %;\
  /endif

/def -i -mregexp -t'^[> ]*Khifayl.*says: Ah, I fear that' Obs_Lights = \
  /if (Obs_Hunt) \
    /eval /set Obs_Check%Obs_Dir 1 %;\
    /echo -aB * Lights in the Sky  (Orient: %Obs_Dir) %;\
    /obs_hunt %;\
  /endif

/def -ip9 -mregexp -t'^[> ]*Khifayl.*says:.*must align it properly first\.[ ]*(The tube is too (low|high)\.)?[ ]*(The stars are too (close|far))?' Obs_Align = \
  /if (Obs_Hunt) \
    d %;\
    /if     (%P2 =~ "low")  /obs_raise %;\
    /elseif (%P2 =~ "high") /obs_lower %;\
    /endif %;\
    /if     (%P4 =~ "close") /obs_zoomout %;\
    /elseif (%P4 =~ "far")   /obs_zoomin  %;\
    /endif %;\
    u\10'clarify %;\
  /endif %;\

/def -i -mregexp -t'^[> ]*Khifayl.*says: The great kren archer' Obs_Diveth = \
  /if (Obs_GotoCheck) /set Obs_GotoCheck=0 %;/endif %;\
  /if (Obs_Hunt) \
    /set Obs_Div=1 %;\
    /set Obs_Div_Dir=%Obs_Dir %;\
    /set Obs_Div_Angle=%Obs_Angle %;\
    /set Obs_Div_Zoom=%Obs_Zoom %;\
    /if (Obs_Target =~ "diveth") \
      /set Obs_Hunt 0 %;\
    /else \
      /obs_nothing %;\
    /endif %;\
  /endif

/def -i -mregexp -t'^[> ]*Khifayl.*says: Hmm, that would be Kahzz' Obs_Kahzz = \
  /if (Obs_GotoCheck) /set Obs_GotoCheck=0 %;/endif %;\
  /if (Obs_Hunt) \
    /set Obs_Khz=1 %;\
    /set Obs_Khz_Dir=%Obs_Dir %;\
    /set Obs_Khz_Angle=%Obs_Angle %;\
    /set Obs_Khz_Zoom=%Obs_Zoom %;\
    /if (Obs_Target =~ "kahzz") \
      /set Obs_Hunt 0 %;\
    /else \
      /obs_nothing %;\
    /endif %;\
  /endif

/def -i -mregexp -t'^[> ]*Khifayl.*says: Myatraa' Obs_Myatraa = \
  /if (Obs_GotoCheck) /set Obs_GotoCheck=0 %;/endif %;\
  /if (Obs_Hunt) \
    /set Obs_Mya=1 %;\
    /set Obs_Mya_Dir=%Obs_Dir %;\
    /set Obs_Mya_Angle=%Obs_Angle %;\
    /set Obs_Mya_Zoom=%Obs_Zoom %;\
    /if (Obs_Target =~ "myatraa") \
      /set Obs_Hunt 0 %;\
    /else \
      /obs_nothing %;\
    /endif %;\
  /endif

/def -i -mregexp -t'^[> ]*Khifayl.*says: Rictus' Obs_Rictus = \
  /if (Obs_GotoCheck) /set Obs_GotoCheck=0 %;/endif %;\
  /if (Obs_Hunt) \
    /set Obs_Ric=1 %;\
    /set Obs_Ric_Dir=%Obs_Dir %;\
    /set Obs_Ric_Angle=%Obs_Angle %;\
    /set Obs_Ric_Zoom=%Obs_Zoom %;\
    /if (Obs_Target =~ "rictus") \
      /set Obs_Hunt 0 %;\
    /else \
      /obs_nothing %;\
    /endif %;\
  /endif

/def -i -mregexp -t'^[> ]*Khifayl.*says: The only beast' Obs_Shengaweh = \
  /if (Obs_GotoCheck) /set Obs_GotoCheck=0 %;/endif %;\
  /if (Obs_Hunt) \
    /set Obs_Shn=1 %;\
    /set Obs_Shn_Dir=%Obs_Dir %;\
    /set Obs_Shn_Angle=%Obs_Angle %;\
    /set Obs_Shn_Zoom=%Obs_Zoom %;\
    /if (Obs_Target =~ "shengaweh") \
      /set Obs_Hunt 0 %;\
    /else \
      /obs_nothing %;\
    /endif %;\
  /endif
