/loaded healer.tf

/set HealerWeapon staff

;; How little SP is too little?
/set oomThreshold 180
/set oomThresholdAutoheal 400

/eval /if (${spiritdisease} =~ '') \
	/def spiritdisease = spiritdisease%; \
/endif

/def -i HealerAction = \
	/autoheal%; \
	/if ({?}) \
		/echo  *** Autoheal!%; \
		/if (HealerCurrSp < oomThresholdAutoheal) /oom%; /endif%; \
	/elseif (TankCurrHp < TankMaxHp * 0.8) \
		/if (inCombat & HealerCurrSp < oomThreshold) /oom%; \
		/else /heal Tank%; \
		/endif%; \
	/elseif (HealerCurrHp < HealerMaxHp * 0.8) /heal Healer%; \
	/elseif (MageCurrHp < MageMaxHp * 0.8) /heal Mage%; \
	/elseif (ThugCurrHp < ThugMaxHp * 0.8) /heal Thug%; \
	/elseif (TankJinx | ThugJinx | HealerJinx | MageJinx) flock cleanse%; \
	/elseif (HealerCurrSp < HealerMaxSp * .5 & HealerIntoxication =~ 'Sober') boozle me%; ,%; \
	/elseif (MageCurrSp < MageMaxSp * 0.3 \
		& MageIntoxication =~ 'Sober' \
		& HealerCurrSp > HealerMaxSp * 0.6) boozle %MageName%; /mage ,%; \
	/elseif (!inCombat & TankCurrHp < TankMaxHp * 0.8) /heal Tank%; \
	/elseif (!TankBarkskin) barkskin %TankName%; \
	/elseif ((targetAcquired | inCombat) & !targetJinx & debuff) glance%; jinx %targetName%; \
	/elseif (targetAcquired & !inCombat & targetJinx < 4 & debuff & rejinx) cleanse %targetName%; \
	/elseif (inCombat & !targetFaerie & debuff) faerie%; \
	/elseif (HealerCurrSp = HealerMaxSp & (TankCurrHp < TankMaxHp | ThugCurrHp < ThugMaxHp | HealerCurrHp < HealerMaxHp | MageCurrHp < MageMaxHp)) \
		flock cure%; \
	/elseif (!inCombat & !symbolFull & HealerCurrSp > HealerMaxSp * 0.9) symbol%; \
	/elseif (inCombat & HealerCurrSp > HealerMaxSp * 0.7 & TankCurrHp > TankMaxHp * 0.8 ) \
		/if (ghost) \
			/if (ghostStone) \
				/if (ghostsKilled > 850) \
					get stone%; \
				/else \
					get stone%; \
				/endif%; \
				stone%; \
			/endif%; \
		/else \
			/if (stone) get stone from box\10stone%; \
			/elseif (!sd) /spiritdisease%; \
			/else %priestSpell%; \
			/endif%; \
		/endif%; \
	/endif

;; Heal one char (e.g. '/heal Mage')
;; Better than 'cure' because it will err on the side of less SP
/def heal = \
	/eval /let delta $$[%{1}MaxHp - %{1}CurrHp]%%; \
		/if (delta < 150 & HealerCurrSp >= 75) cure critical %%{%{1}Name}%%; \
		/elseif (delta < 300 & HealerCurrSp >= 115) cure mortal %%{%{1}Name}%%; \
		/elseif (delta < 600 & HealerCurrSp >= 180) cure deadly %%{%{1}Name}%%; \
		/else cure %%{%{1}Name}%%; \
		/endif

;; Magical macro that checks everyone's HP and uses the appropriate 'flock cure X'
;; Or none at all, saving SP over casting 'flock cure' all willy-nilly.
;; In depth example:
;; Three chars are missing 100 HP each.  One char is missing 200.  'flock cure' would
;; cast three 'cure mortal' and one 'cure deadly', which is a ton of overhealing.
;; Instead, this will cast 'flock cure critical', curing 3 chars most (or all) of the way,
;; and leaving one char with 50-100 HP missing.
;; On the other hand, if that one char was missing 600 HP, it would cast 'flock cure',
;; sending out three 'cure mortal' and one 'cure greivous', because the underhealing of
;; 'cure critical' on 600 HP outweighs the overhealing of 'cure mortal' on 100HP.
/def autoheal = \
	/let dhpMage=$[MageMaxHp - MageCurrHp]%; \
	/let pcthpMage=$[MageCurrHp * 1.0 / MageMaxHp]%; \
	/let dhpHealer=$[HealerMaxHp - HealerCurrHp]%; \
	/let pcthpHealer=$[HealerCurrHp * 1.0 / HealerMaxHp]%; \
	/let dhpThug=$[ThugMaxHp - ThugCurrHp]%; \
	/let pcthpThug=$[ThugCurrHp * 1.0 / ThugMaxHp]%; \
	/let dhpTank=$[TankMaxHp - TankCurrHp]%; \
	/let pcthpTank=$[TankCurrHp * 1.0 / TankMaxHp]%; \
	/if (numLessThan(0.7, pcthpMage, pcthpHealer, pcthpThug, pcthpTank) > 1) \
		/let maxDelta=$[max(dhpTank, dhpThug, dhpHealer, dhpMage)]%; \
		/let lastUnderHealing=$[underHealing(maxDelta, 1)]%; \
		/for i 2 6 \
			/let overHealing=$$[overHealing(maxDelta, i)]%%; \
			/if (overHealing > 0) \
				/if (overHealing < lastUnderHealing) \
					/eval /echo flock cure $$[wordForLevel(i)]%%; \
					/return wordForLevel(i)%%; \
				/else \
					/eval /echo flock cure $$[wordForLevel(i-1)]%%; \
					/return wordForLevel(i-1)%%; \
				/endif%%; \
			/endif%%; \
			/let lastUnderHealing=$$[underHealing(maxDelta, i)]%; \
		/let cureType=%{?}%; \
		/if (cureType !~ '7') \
			flock cure %cureType%; \
		/else \
			flock cure%; \
		/endif%; \
		/return 1%; \
	/else \
		/return 0%; \
	/endif


; Type          Spell Point Cost       Amount Healed       Minimum Level
;                (success/fail)
; =========================================================================
; light             25 /  5                 20                  1st
; serious           40 / 10                 45                 14th
; critical          75 / 15                 95                 22nd
; mortal           115 / 20                150                 30th
; deadly           180 / 25                300                 38th
; grievous         360 / 75                650                 52nd

/set cureLevels light serious critical mortal deadly

/def -i wordForLevel = \
	/listItem %1 %cureLevels

/def -i listItem = \
	/let itemNum=%1%; \
	/shift%; \
	/return {%itemNum}

/def -i overHealing = \
	/let delta=%1%; \
	/if ({#} > 1) \
		/let level=%2%; \
	/else \
		/let level=6%; \
	/endif%; \
	/if (level >= 1 & delta < 20) /return 20 - delta%; \
	/elseif (level >= 2 & delta < 45) /return 45 - delta%; \
	/elseif (level >= 3 & delta < 95) /return 95 - delta%; \
	/elseif (level >= 4 & delta < 150) /return 150 - delta%; \
	/elseif (level >= 5 & delta < 300) /return 300 - delta%; \
	/elseif (level >= 6 & delta < 650) /return 650 - delta%; \
	/else /return 0%; \
	/endif

/def -i underHealing = \
	/let delta=%1%; \
	/if ({#} > 1) /let level=%2%; \
	/else /let level=6%; \
	/endif%; \
	/if (level <= 1 & delta > 20) /return delta - 20%; \
	/elseif (level <= 2 & delta > 45) /return delta - 45%; \
	/elseif (level <= 3 & delta > 95) /return delta - 95%; \
	/elseif (level <= 4 & delta > 150) /return delta - 150%; \
	/elseif (level <= 5 & delta > 300) /return delta - 300%; \
	/elseif (delta > 650) /return delta - 650%; \
	/else /return 0%; \
	/endif

/def -i numLessThan = \
	/let targetNum=%1%; \
	/let num=0%; \
	/shift%; \
	/while ({#}) \
		/if ({1} < targetNum) /let num=$[num+1]%; \
		/endif%; \
		/shift%; \
	/done%; \
	/return %num

/def -i max = \
	/let max=0%; \
	/while ({#}) \
		/if ({1} > max) /let max=%1%; \
		/endif%; \
		/shift%; \
	/done%; \
	/return max

/def -wHealer -msimple -t'You call forth a holy symbol from Llardin.' symbolCreated = /set symbolFull 0
/def addSymbol = /repeat -wHealer -2 1 symbol%%; /if (!symbolFull & autocast) /addSymbol%%; /endif
/def -wHealer -msimple -t'You have added another charge to your symbol.' symbolNotFull = /set symbolFull 0
;/def -wHealer -msimple -t"Your symbol flares into brilliance as Llardin's beneficence shields you from damage!" symbolUsed = /set symbolFull 0
/def -wHealer -msimple -t'You are ready to bring forth a new symbol.' symbolReady = /set symbolFull 0
/def -wHealer -mglob -t'You feel the symbol is absolutely full of holy energy.' symbolFull = /set symbolFull 1

/def -wHealer -mglob -t'You mutter a malignant prayer, and attempt to curse * with a diseased spirit!' sdOn = \
	/set sd 1
/def -wHealer -mglob -t'Your attention is already occupied with the task of maintaining a diseased force*' sdAlready = \
	/set sd 1
/def -wHealer -msimple -t'Your prayers to Llardin fall on deaf ears.' sdImmune = /set sd 1
/def -wHealer -mglob -t'You grow tired, and your hold on * spirit collapses!' sdOff = \
	/set sd 0
/def -wHealer -mglob -t'You find it too difficult to channel the energies across the distance*' sdTooFar = \
	/set sd 0
/def -wHealer -mglob -t"You try to afflict * with a nasty disease, but he shrugs off its effects." sdMiss = \
	/set sd 0
/def -wHealer -mglob -t"* doesn't even get a headache from the effects of your disease." sdMiss2 = \
	/set sd 0
/def -wHealer -mglob -t"You call on Llardin's darker side, but * only looks slightly flushed." sdMiss3 = \
	/set sd 0

/set targetJinx 0
/def -msimple -t'The target is already jinxed!' jinxAlready = /set targetJinx -1
/def -mglob -t'* is too balanced to be jinxed.' jinxImmune = /set targetJinx -1
/def -mglob -t'*muscles firm up*' jinxOff = /set targetJinx 0
/eval /def -mregexp -p9 -t'(%TankName|%HealerName|%MageName|%ThugName) looks much steadier on its feet.' playerJinxOff = 
/def -mglob -t'*looks much steadier on*feet.' jinxOff2 = /set targetJinx 0
/def -mregexp -t'^You make the sign of a hex.*stagger ([a-z]+)' jinx1 = /jinxeval %P1
;;/def -mregexp -t'([a-z]+) as .* limbs turn to jello' jinx2 = /jinxeval %P1
/def jinxeval = \
		/if (%{1} =~ 'slightly') /jinxresult 1%; \
		/elseif (%{1} =~ 'somewhat') /jinxresult 2%; \
		/elseif (%{1} =~ 'moderately') /jinxresult 3%; \
		/elseif (%{1} =~ 'notably') /jinxresult 4%; \
		/elseif (%{1} =~ 'horribly') /jinxresult 5%; \
		/elseif (%{1} =~ 'exceptionally') /jinxresult 6%; \
		/else /jinxresult -1%; \
		/endif
/def jinxresult = /set targetJinx %{1}

/def -mglob -t'* stops glowing.' faerieOff = /set targetFaerie 0
/def -mregexp -t'You murmur a prayer, and .* glows ([a-z ]+)\.$' faerieOn = \
	/if ({P1} =~ 'very faintly') /faerieResult 1%; \
	/elseif ({P1} =~ 'faintly') /faerieResult 2%; \
	/elseif ({P1} =~ 'dimly') /faerieResult 3%; \
	/elseif ({P1} =~ 'somewhat') /faerieResult 4%; \
	/elseif ({P1} =~ 'brightly') /faerieResult 5%; \
	/elseif ({P1} =~ 'very brightly') /faerieResult 6%; \
	/elseif ({P1} =~ 'extremely brightly') /faerieResult 7%; \
	/elseif ({P1} =~ 'brilliantly') /faerieResult 8%; \
	/else /faerieResult -1%; \
	/endif
/def faerieResult = /set targetFaerie %{1}

/def -mglob -t'The creature is already affected!' faerieAlready = /set targetFaerie 1
/def getstone = /if (world_info() =~ 'Healer') get stone\10get stone from corpse\10put all in box%; /endif

;; See when confess finishes while you're in another socket
/def -wHealer -msimple -t'You land in the Cathedral, to the shocked surprise of others around you.' confessDone = /echo *** Confess finished.


;; Trigs for collecting stones from Observatory bag (useful for ghosts)

/def stone = /healer get stone from box\10stone

/def -wHealer -msimple -t'Harsh metallic grinding noises emanate from the stony bag.  With a brief emanation of heat, it quiets down.' bagAte = \
	/set bagHungry 1

/def -wHealer -msimple -t'A noise remarkably like a stomach growling emerges from the bag.' bagEmpty = \
	/set bagHungry 1

/def -wHealer -msimple -t'The bag twitches somewhat, then convulses and seems to flop back, almost gasping.  Its contents remain untouched.' bagFull = \
	/set bagHungry 0%; \
	/if (!feedTimer) \
		/set feedTimer 1%; \
		/repeat -w -300 1 /set feedTimer 0%%; /feedBag%; \
	/endif

/def -wHealer -msimple -t'a valuable gemstone: Taken.' gotGem = /set gotGem 1

/def getGem = close bag%; open bag%; \
	/repeat -w -2 1 \
		get all from bag\10put all in box\10drop all%; \
	/repeat -w -3 1 \
		/if (gotGem) \
			/getGem%%; \
		/else \
			/if (bagHungry) \
				/feedBag%%; \
			/endif%%; \
		/endif%%; \
		/set gotGem 0

/def feedBag = open bag%; get 25000 coins%; put 25000 coins in bag%; drop money%; close bag%; /repeat -w -2 1 /getGem

