
; Edited for TF v5 11/24/04 by Silk
;
; Makepath.tf
; A quicker and more intelligent /dopath.
;
; Questions, comments, criticisms to Symbolic.
;
/loaded makepath.tf

/def -i mpDef2 = /def -i -- mp%{*}
/def -i mpDef3 = /def -i -- %{*}

; Aliasing Defintion

/mpDef2 Alias = /set mp_%{1}=%{-1}
/mpDef2 Expand = /eval /cdr %%{mp_%{1}}
/mpDef2 Cancel = /eval /car %%{mp_%{1}}

; Path define macros

/mpDef3 mpDef = \
   /set mpLocList=%{1} %;\
   /while /shift %; /test {1} !~ "=" %; /do \
      /uPush %{1} mpLocList %;\
      /done %;\
   /shift %;\
   /while /test $(/length %{mpLocList}) > 0 %; /do \
      /let Location=$(/uPop mpLocList) %;\
      /let Prefix=$[substr(Location,0,2)] %;\
      /if /test (Prefix =~ "->" | Prefix =~ "<-") %; /then \
          /mpDef3 %{Location} = %{*} %;\
       /else \
          /mpDef3 ->%{Location} = %{*} %;\
          /mpDef3 <-%{Location} = $(/mpReverse %{*}) %;\
       /endif %;\
   /done %;\
   /unset mpLocList

; Convienence macros

/mpDef2 Clear = \
   /purge -i -- ->* %;\
   /purge -i -- <-*

/mpDef2 Load = \
   /mpClear %;\
   /load %{*}

/mpDef2 Help = \
   /mpecho %;\
   /mpecho Makepath.tf Help %;\
   /mpecho %;\
   /mpecho /to Loc               - Moves you from cath to Loc. %;\
   /mpecho /from Loc             - Moves you from Loc to cath. %;\
   /mpecho /goto Loc (from Loc2) - Moves you from current location to Loc. %;\
   /mpecho /domove path          - Works like /dopath only faster. %;\
   /mpecho /where (Loc)          - Shows you where makepath.tf thinks you are, %;\
   /mpecho .                       or sets your current location to Loc. %;\
   /mpecho %;\
   /mpecho /mpdef Loc = path     - Define a location. (Auto makes -> & <-) %;\
   /mpecho /mpdef ->Loc = path   - Define a to Loc macro. %;\
   /mpecho /mpdef <-Loc = path   - Definte a from Loc macro. %;\
   /mpecho /mpgag (on|off)       - Set default gagging on or off. %;\
   /mpecho %;\
   /mpecho Note path can be single directions (n, s, e), a repeated %;\
   /mpecho direction (4 n, 3 s), even to/from macros (->augustina, %;\
   /mpecho <-wynt). %;\
   /mpecho %;\
   /mpecho /to, /from, /goto, and /domove all accept a -g flag for only gagging %;\
   /mpecho a single movement. (ex. /to -g augustina) %;\
   /mpecho

; Move macros

/mpDef3 Goto = \
   /if /test {1} =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test {2} =~ "from" %; /then \
       /set mpTempLoc=%{3} %;\
    /else \
       /set mpTempLoc=%{mpCurLoc} %;\
    /endif %;\
   /if /test mpTest("%{mpTempLoc}","<-") %; /then /break %; /endif %;\
   /if /test mpTest("%{1}","->") %; /then /break %; /endif %;\
   /DoMove $(/mpReverse %{mpCurTrack}) <-%{mpTempLoc} ->%{1} %;\
   /set mpCurLoc=%{1} %;\
   /set mpCurTrack= %;\
   /unset mpTempLoc

/mpDef3 To = \
   /if /test {1} =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test mpTest("%{1}","->") %; /then /break %; /endif %;\
   /DoMove ->%{1} %;\
   /set mpCurLoc=%{1} %;\
   /set mpCurTrack=

/mpDef3 From = \
   /if /test {1} =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /if /test mpTest("%{1}","<-") %; /then /break %; /endif %;\
   /DoMove <-%{1} %;\
   /set mpCurLoc=cath %;\
   /set mpCurTrack= %;\

/mpDef3 PrintMove = \
   /set mpCurPath= %;\
   /mpEvalPath %{*} %;\
   /echo %{mpCurPath} %;\
   /unset mpCurPath

/mpDef3 DoMove = \
   /if /test {1} =~ "-g" %; /then \
       /let Gag=1 %;\
       /shift %;\
    /endif %;\
   /set mpCurPath= %;\
   /mpEvalPath %{*} %;\
   /mpGo %{mpCurPath} %;\
   /unset mpCurPath

/mpDef3 Where = \
   /if /test {#} != 0 %; /then \
       /if /test uMacroExist("->%{1}") %; /then \
           /set mpCurLoc=%{1} %;\
           /set mpCurTrack= %;\
        /else \
           /mpecho Location %{1} unknown. %;\
       /endif %;\
    /endif %;\
   /mpecho Current location: %{mpCurLoc} %;\
   /if /test mpTrack =~ "on" %; /then \
       /mpecho Currect tracking: %{mpCurTrack} %;\
    /endif

/mpDef2 Gag = \
   /if /test {1} =~ "on" %; /then \
       /set mpGagDefault=1 %;\
    /endif %;\
   /if /test {1} =~ "off" %; /then \
       /set mpGagDefault= %;\
    /endif %;\
   /if /test mpGagDefault %; /then \
       /mpecho Gagging is enabled. %;\
    /else \
       /mpecho Gagging disabled. %;\
    /endif

/mpDef2 Precmd = /mpPrefix %{*}
/mpDef2 Prefix = \
   /set mpMovePrefix=%{*} %;\
   /mpecho Move Prefix set to: %{mpMovePrefix}

/mpDef2 Postcmd = /mpSuffix %{*}
/mpDef2 Suffix = \
   /set mpMoveSuffix=%{*} %;\
   /mpecho Move Suffix set to: %{mpMoveSuffix}

/mpDef2 Stats = \
   /mpecho Move Prefix set to: %{mpMovePrefix} %;\
   /mpecho Move Suffix set to: %{mpMoveSuffix} %;\
   /mpecho Current Location: %{mpCurLoc}

; Internal macros

/mpDef2 Go = \
   /let mpGoTemp= %;\
   /while /test {#} %; /do \
      /let mpNextCmd=$(/mpExpand %{1}) %;\
      /if /test mpNextCmd!~"" %; /then \
          /let mpGoTemp=$[strcat(%{mpGoTemp},%{mpNextCmd},"\\10")] %;\
       /else \
          /let mpGoTemp=$[strcat(%{mpGoTemp},%{1},"\\10")] %;\
       /endif %;\
      /shift %;\
   /done %;\
   /if /test mpMovePrefix !~ "" %; /then \
       %{mpMovePrefix} %;\
    /endif %;\
   /if /test (Gag | mpGagDefault) %; /then \
       /uGag -s glance %{mpGoTemp} %;\
    /else \
       /eval %{mpGoTemp} %;\
    /endif %;\
   /if /test mpMoveSuffix !~ "" %; /then \
       %{mpMoveSuffix} %;\
    /endif

/mpDef2 EvalPath = \
   /while /test {#} %; /do \
       /let Prefix=$[substr(%1,0,2)] %;\
       /if /test (Prefix =~ "->" | Prefix =~ "<-") %; /then \
               /if /test mpTest("%{1}") %; /then %;\
                   /set mpCurPath= %;\
                   /break %;\
                /endif %;\
               /eval /mpEvalPath $${%{1}} %;\
               /shift %;\
       /elseif /test \%{1} != 0 %; /then \
           /for i 1 %1 /mpAddPath %{2} mpCurPath%;\
           /shift 2 %;\
        /else \
           /mpAddPath %{1} mpCurPath %;\
           /shift %;\
        /endif %;\
   /done %;\
   /unset mpTempPath

/mpDef2 AddPath = \
   /eval /set mpTempPath=%%{%{2}} %;\
   /let NewDir=%{1} %;\
   /let NewDirC=$(/mpCancel %{NewDir}) %;\
   /while /test 1 %; /do \
      /let LastDir=$(/clst %{mpTempPath}) %;\
      /let LastDirC=$(/mpCancel %{LastDir}) %;\
      /if /test LastDir =~ NewDirC & NewDirC !~ "" %; /then \
          /set %{2}=$(/nlst %{mpTempPath}) %;\
          /break %;\
       /endif %;\
      /if /test LastDirC !~ "-" & LastDirC !~ "" %; /then \
          /eval /set %{2}=%%{%{2}} %{NewDir} %;\
          /break %;\
       /endif %;\
      /set mpTempPath=$(/nlst %{mpTempPath}) %;\
      /if /test mpTempPath =~ "" %; /then \
          /eval /set %{2}=%%{%{2}} %{NewDir} %;\
          /break %;\
       /endif %;\
    /done

/mpDef2 Reverse = \
   /set mpRevPath= %;\
   /set mult= %;\
   /while /test {#} %; /do \
      /let Prefix=$[substr({1},0,2)] %;\
      /if /test Prefix =~ "->" %; /then \
          /eval /uPush <-$$[substr({1},2)] mpRevPath %;\
          /set mult= %;\
       /elseif /test Prefix =~ "<-" %; /then \
          /eval /uPush ->$$[substr({1},2)] mpRevPath %;\
          /set mult= %;\
       /elseif /test mp_%{1}!~"" %; /then \
          /set ReverseDir=$(/mpCancel %{1}) %;\
          /if /test ReverseDir !~ "-" %; /then \
              /uPush %{ReverseDir} mpRevPath %;\
           /else \
              /set mult= %;\
           /endif %;\
          /if /test mult > 0 %; /then \
              /uPush %{mult} mpRevPath %;\
              /set mult= %;\
           /endif %;\
       /elseif /test {1} > 0 %; /then \
          /set mult=%{1} %;\
       /else \
          /uPush %{1} mpRevPath %;\
          /if /test mult > 0 %; /then \
              /uPush %{mult} mpRevPath %;\
              /set mult= %;\
           /endif %;\
       /endif %;\
      /shift %;\
    /done %;\
   /echo -- %{mpRevPath} %;\
   /unset mult %;\
   /unset mpRevPath

/mpDef2 Test = \
   /if /test !uMacroExist("%{2}%{1}") %; /then \
       /mpecho Path %{2}%{1} not defined. %;\
    /endif %;\
   /test !uMacroExist("%{2}%{1}")

/mpDef3 clst = /echo -- %L1
/mpDef3 nlst = /echo -- %-L1

/mpDef2 Echo = /echo -aB -- * %{*}

; Tracking additions

/mpDef2 AddTrack = \
   /set mpCurTrack=%{mpCurTrack} %{*} %;\
   /send %{*}

/mpDef2 Track = \
   /if /test {1} =~ "on" | {1} =~ "off" %; /then \
       /set mpTrack=%{1} %;\
    /endif %;\
   /purge mpTrackHook %;\
   /if /test mpTrack =~ "on" %; /then \
       /def -p9999 -h'send {n|s|e|w|u|d|enter|out|nw|ne|sw|se}' mpTrackHook \
          = /mpAddTrack %%* %;\
    /endif %;\
   /mpecho Tracking %{mpTrack}.

; Quit macro

/mpDef2 Quit = /purge -i clst %;\
              /purge -i nlst %;\
              /purge -i mp* %;\
              /echo * Makepath.tf removed.

; Startup message/Version info

/mpecho Makepath.tf v2.0 ready.
/mpecho Questions, comments, criticisms to Symbolic.

/mpDef2 Ver = /echo @(#) makepath.tf  v2.0  (4/27/96)

; Test for util.tf

/if /test util_tf < 5 %; /then \
    /mpecho Warning: util.tf v5 required. %;\
 /endif

; Default aliases

/mpalias n s !n
/mpalias s n !s
/mpalias e w !e
/mpalias w e !w
/mpalias ne sw !ne
/mpalias sw ne !sw
/mpalias nw se !nw
/mpalias se nw !se
/mpalias u d !u
/mpalias d u !d
/mpalias in out !in
/mpalias out in !out


