;; Trigs for a fighter that will lead the botting party

/loaded thug.tf

;; To avoid wielding phoenix spear or vorpal flail in town
/registerListener inCombat wieldSpear
/registerListener mobDied unwieldSpear

/if (ThugWeapon =~ '') /set ThugWeapon phoenix spear%; /endif
/def wieldSpear = /thug wield %ThugWeapon
/def unwieldSpear = /if (ThugWeapon =~ 'phoenix spear' | ThugWeapon =~ 'vorpal flail') unwield %ThugWeapon%; /endif
/def -wThug -mregexp -t"You'll have to lose the (.*) first." shieldInTheWay = remove %P1

/def ThugAction = \
	/if (!ready & !regrouping & botting) \
		/let readyNow=1%; \
		/if (regrouping) \
			/let readyNow=0%; \
		/elseif (donating) \
			/if (mpCurLoc !~ 'booth' & pathable) /goto booth%; /donateStuff%; /endif%; \
			keep %container%; \
			/let readyNow=0%; \
		/elseif (containerFull & pathable) \
;			/set donating 1%; /goto booth%; /donateStuff%; \
			/goto macs%; sell all from %container%; put 4000 coins in %moneycontainer%; keep %container%; \
			/let readyNow=0%; \
		/elseif (alcohol =~ 'empty' & alcoholToBuy !~ '' & pathable) \
			/goto drink%; get all from %moneycontainer%; buy %alcoholToBuy%; keep %alcohol%; /handleMoney%; \
		/else \
			drop %{alcohol}%; \
		/endif%; \
		/if (HealerIntoxLevel < 3) \
			/if (HealerCurrSp < HealerMaxSp * 0.8) \
				/let readyNow=0%; \
				/getHealerSp%; \
			/endif%; \
		/else \
			/healer ,%; \
			/let readyNow=0%; \
		/endif%; \
		/if (MageIntoxLevel < 3) \
			/if (alcohol !~ '' & alcohol !~ 'empty' & MageCurrSp < MageMaxSp * 0.4) \
				/let readyNow=0%; \
				/getMageSp%; \
			/endif%; \
		/elseif (MageIntoxLevel > 4 & MageCurrSp < MageMaxSp) \
			/mage ,%; \
			/let readyNow=0%; \
		/endif%; \
		/if (TankCurrHp < TankMaxHp * 0.8 \
				| MageCurrHp < MageMaxHp * 0.8 \
				| HealerCurrHp < HealerMaxHp * 0.8 \
				| ThugCurrHp < ThugMaxHp * 0.8) \
			/let readyNow=0%; \
		/endif%; \
		/if (TankEntangle | HealerEntangle | MageEntangle | ThugEntangle) \
			/let readyNow=0%; \
		/endif%; \
		/if (readyNow) \
			get %{alcohol}%; \
			keep %{alcohol}%; \
			/goto target%; \
			/eval /kill%{target}%; \
			/set ready 1%; \
		/endif%; \
	/elseif (inCombat) \
		/if (ghost) \
			/if (charge !~ 'active' & berserk !~ 'active' & !ghostAlmostDead) \
				/if (ghostCharge & ThugCurrSp > 300) \
					/if (charge =~ 'ready' & (ghostbashed > 1 | !bash)) \
						/if (ghostsKilled < 300) \
							/set bashers Tank Thug%; \
						/endif%; \
						/repeat -40 1 /set bashers Thug Tank%; \
						/ghostCharge%; \
					/endif%; \
				/elseif ((ghostZerk | ThugCurrSp <= 300) & berserk =~ 'ready' & (ghostbashed > 0 | !bash)) \
					/if (superbash) \
						/set bashers Thug Tank%; \
					/else \
						/set bashers Tank Thug%; \
					/endif%; \
					berserk%; \
				/endif%; \
			/elseif (berserk =~ 'active' & punch =~ 'ready' & (ghostbashed > 1 | !bash)) \
				punch%; \
			/endif%; \
		/else \
			/if (berserk =~ 'ready' & charge !~ 'active') /goberserk%; \
			/elseif (berserk =~ 'active' & punch =~ 'ready') punch%; \
			/endif%; \
		/endif%; \
	/endif

/def goberserk = berserk
/def stopberserk =
/def replaceBerserkTrig = /set goberserktmp=${goberserk}%; /def goberserk = %*
/def restoreBerserkTrig = /def goberserk = %goberserktmp

/def -wThug -mglob -t'You feel anger awaken deep within yourself.' berserkReady = /set berserk ready
/def -wThug -mglob -t'   Berserk:     inactive' berserkReadyReport = /set berserk ready
/def -wThug -mglob -t'Your body seems stronger as the aches from your great exertion diminish.' berserkRecovering = \
	/set berserk recovering%; /stopberserk
/def -wThug -mglob -t'   Berserk:     recovering' berserkRecoveringReport = /set berserk recovering
/def -wThug -mglob -t'You go berserk!' berserkActive = /set berserk active
/def -wThug -mglob -t'   Berserk:     Gnash! Gnash! Raaaaar!' berserkActiveReport = /set berserk active
/def -wThug -mglob -t"You can't find an opening to punch." punchAborted = /set punch ready
/def -wThug -mglob -t'Punch whom?' punchNoTarget = /set punch ready
/def -wThug -mglob -t'Your arm feels stronger again.' punchReady = /set punch ready
/def -wThug -mglob -t'Current status:' punchClearReport = /set punch ready
/def -wThug -mglob -t'   Punch:       recovering' punchRecoveringReport = /set punch recovering
/def -wThug -mglob -q -h'SEND punch' punchSentHook = /set punch recovering
/def -wThug -mglob -q -h'SEND k *' killSentHook = /wieldspear
/def -wThug -mglob -t'No * here !' killFailed = /unwieldspear
/def -wThug -mglob -t'You charge out of the room, swinging your *' chargeOn = /set charge active
/def -wThug -msimple -t'You wind up and get ready to charge!' chargeOn2 = /set charge active
/def -wThug -mglob -t'You feel your rage wear off.' chargeRecovering = /set charge recovering
/def -wThug -mglob -t'You feel less winded.' chargeReady = /set charge ready
/def -wThug -mglob -t'* takes one look at you, shrieks in terror and runs from the room!' chargeScare = /set charge ready
/def -wThug -msimple -t'   CHARGE!:     inactive' chargeReadyReport = /set charge ready
/def -wThug -msimple -t'   CHARGE!:     recovering' chargeRecoveringReport = /set charge recovering
/def -wThug -msimple -t'   CHARGE!:     CHARGING!' chargeActiveReport = /set charge active

/def spearcost = /repeat -S 1 \
			/setupSkillValue two-handed 3 polearm 8 dexterity 10 strength 12 damage%%; \
			/echo Damage:%%; cost two-handed 3%%;cost polearm 8%%;cost dexterity 10%%;cost strength 12%; \
		 /repeat -1 1 /eval /echo Current Damage rating: %%{damage}%%; \
			/setupSkillValue attack 1 polearm 1 two-handed 1 resistance 4 dexterity 6 hit%%; \
			/echo Hit:%%; cost attack%%; cost polearm%%; cost two-handed%%; cost resistance 4%%; cost dexterity 6%; \
		 /repeat -2 1 /eval /echo Current Hit rating: %%hit%%; \
			/setupSkillValue critical 3 two-handed 6 polearm 10 dexterity 20 intelligence 60 perception 60 crit%%; \
			/echo Crit:%%; cost critical 3%%; cost two-handed 6%%; cost polearm 10%%; cost dexterity 20%%; \
				cost intelligence 60%%; cost perception 60%; \
		/repeat -3 1 /eval /echo Current Crit rating: $$[crit * 2]

/def flailcost = /repeat -S 1 \
			/setupSkillValue two-handed 2 mace 2 dexterity 10 strength 10 damage%%; \
			/echo Damage:%%; cost two-handed 2%%;cost mace 2%%;cost dexterity 10%%;cost strength 10%; \
		 /repeat -1 1 /eval /echo Current Damage rating: %%{damage}%%; \
			/setupSkillValue attack 1 mace 1 two-handed 1 strength 4 dexterity 6 hit%%; \
			/echo Hit:%%; cost attack%%; cost mace%%; cost two-handed%%; cost strength 4%%; cost dexterity 6%; \
		 /repeat -2 1 /eval /echo Current Hit rating: %%hit%%; \
			/setupSkillValue critical 6 two-handed 15 mace 25 dexterity 30 intelligence 150 perception 150 crit%%; \
			/echo Crit:%%; cost critical 6%%; cost two-handed 15%%; cost mace 25%%; cost dexterity 30%%; \
				cost intelligence 150%%; cost perception 150%; \
		/repeat -3 1 /eval /echo Current Crit rating: $$[crit * 5]

; /setupSkillValueTrig (<Raw State Name> <Coefficient>)... <Calculated State Name>
; Value of Raw Stat / Coefficient = value of Calculated Stat
/def setupSkillValue = \
	/eval /set %L1=0%; \
	/while (%{#} > 2) \
		/def -1 -mregexp -t'^The cost to raise your %1 from ([0-9]+)' %{1}Value = /set %L1=$$[%L1 + (%%P1/%2)]%; \
		/shift 2%; \
	/done

