;
; sigil.tf
;
; Detects all kinds of sigils, calls /sigilhook when sigil is detected.
; Original sigils.tf by Ai.
;
; Questions, comments, criticisms to Symbolic.
;

; Queue macros

/def sigilPutQ = /uPutQ %1 sigilTypeQ %;\
                 /uPutQ %2 sigilByQ
/def sigiltPutQ = /uPutQ %1 sigilTypeQ
/def sigiltGetQ = /uGetQ sigilType
/def sigilbPutQ = /uPutQ %1 sigilByQ
/def sigilbGetQ = /uGetQ sigilByQ

/def sigilClearQ = /set sigilTypeQ= %; /set sigilByQ=

; fighter sigils
; priorities are because the trigger messages are similar.

/def -mregexp -p1 -it"^([A-Z][a-z]*)'s squire stands guard over .+\." \
 sigilFighter = \
  /sigilPutQ Fighter %P1 %;\
  /sigilCallHook

/def -mregexp -p2 -it"^([A-Z][a-z]*)'s squire stands guard over the room\." \
 sigilFighterRoom =\
  /sigilPutQ FighterRoom %P1 %;\
  /sigilCallHook

; mage sigils
/def -mregexp -it"^([A-Z][a-z]*)'s .* zips, dodges and weaves vigilantly \
 about .+\." sigilMage=\
  /sigilPutQ Mage %P1 %;\
  /sigilCallHook

/def -mregexp -p2 -it"^([A-Z][a-z]*)'s .* zips, dodges and weaves vigilantly \
 about the room\." sigilMageRoom = \
  /sigilPutQ MageRoom %P1 %;\
  /sigilCallHook

; priest sigils
/def -mregexp -p1 -it"^([A-Z][a-z]*)'s acolyte keeps silent vigil over .+\." \
 sigilPriest = \
  /sigilPutQ Priest %P1 %;\
  /sigilCallHook

/def -mregexp -p2 -it"^([A-Z][a-z]*)'s acolyte keeps silent vigil over the \
 room\." sigilPriestRoom = \
  /sigilPutQ PriestRoom %P1 %;\
  /sigilCallHook

; thief sigils
/def -mregexp -p1 -it"A dirty street urchin keeps a wary eye on .* for \
 ([A-Z][a-z]*)\." sigilThief = \
  /sigilPutQ Thief %P1 %;\
  /sigilCallHook

/def -mregexp -p2 -it"A dirty street urchin keeps a wary eye on the room \
 for ([A-Z][a-z]*)\." sigilThiefRoom = \
  /sigilPutQ ThiefRoom %P1 %;\
  /sigilCallHook

; Hook

/def sigilCallHook = \
   /uCallHook sigilHook

/def sigilHook

; In/out sigil detect
; Requires io.tf

/def sigilCheck = \
   /set sigilInHook=%{1} %;\
   /set sigilOutHook=%{2} %;\
   /uaPutQ sigilIn %; /uaPutQ sigilOut %;\
   , %; /iopeek %; ,

/def sigilIn = \
   /sigilClearQ %;\
   /set sigilDetect= %;\
   /uCallVarHook sigilInHook

/def sigilOut = \
   /if /test strlen(sigilTypeQ) %; /then \
       /set sigilDetect=1 %;\
    /endif %;\
   /uCallVarHook sigilOutHook
