;;; skymark.tf
;;;
;;; macros for moving through skymark quickly
;;; use '/skyred', '/skyenter', '/skycenter' etc
;;;
;;; Created: Dec 2003 by Meteor
;;;
;;;
/set skysearching=0
/set wantblue=0
/set wantred=0
/set wantgreen=0
/set wantcenter=0
/set wantenter=0
/def skyblue = /set wantblue=1%;/set skysearching=1%;glance
/def skygreen = /set wantgreen=1%;/set skysearching=1%;glance
/def skyred = /set wantred=1%;/set skysearching=1%;glance
/def skycenter = /set wantcenter=1%;/set skysearching=1%;glance
/def skyenter = /set wantenter=1%;/set skysearching=1%;glance

/def -p0 -mglob -t'*clearing in the tangled copse*' sky_fodder = \
  /if /test %skysearching = 1%; /then \
      push north%; \
  /endif

/def -p0 -mglob -t'*Inside the Grymwald Forest (north and southeast)*' sky_grym = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantenter = 1%; /then \
          /set skysearching=0%;/set wantenter=0%; \
      /else /eval north%; \
      /endif%; \
  /endif

/def -p0 -mglob -t'*ntrance clearing*' sky_enter = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantenter = 1%; /then \
          /set skysearching=0%;/set wantenter=0%; \
      /else push north%; \
      /endif%; \
  /endif

/def -p0 -mglob -t'*strangely blue clearing*' sky_blue = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantblue = 1%; /then \
          /set skysearching=0%;/set wantblue=0%; \
      /else push north%; \
      /endif%; \
  /endif
   
/def -p0 -mglob -t'*n odd blue clearing*' sky_blue2 = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantblue = 1%; /then \
          /set skysearching=0%;/set wantblue=0%; \
      /else push north%; \
      /endif%; \
  /endif

/def -p0 -mglob -t'*entral clearing*' sky_center = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantcenter = 1%; /then \
          /set skysearching=0%;/set wantcenter=0%; \
      /else push north%; \
      /endif%; \
  /endif
  
/def -p0 -mglob -t'*strange green clearing*' sky_green = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantgreen = 1%; /then \
          /set skysearching=0%;/set wantgreen=0%; \
      /else push north%; \
      /endif%; \
  /endif
  
/def -p0 -mglob -t'*n intensely green clearing*' sky_green2 = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantgreen = 1%; /then \
          /set skysearching=0%;/set wantgreen=0%; \
      /else push north%; \
      /endif%; \
  /endif
  
/def -p0 -mglob -t'*strange red clearing*' sky_red = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantred = 1%; /then \
          /set skysearching=0%;/set wantred=0%; \
      /else push north%; \
      /endif%; \
  /endif
  
/def -p0 -mglob -t'*glowing red clearing*' sky_red2 = \
  /if /test %skysearching = 1%; /then \
      /if /test %wantred = 1%; /then \
          /set skysearching=0%;/set wantred=0%; \
      /else push north%; \
      /endif%; \
  /endif
  
/def skyquit = \
 /undef skyblue%; \
 /undef skygreen %; \
 /undef skyred %; \
 /undef skycenter %; \
 /undef skyenter %; \
 /undef sky_fodder %; \
 /undef sky_grym %; \
 /undef sky_enter %; \
 /undef sky_blue %; \
 /undef sky_blue2 %; \
 /undef sky_center %; \
 /undef sky_green %; \
 /undef sky_green2 %; \
 /undef sky_red %; \
 /undef sky_red2 %; \
 /undef skyquit

; Item Prediction
/def -i SkyPredict = \
  /if ({#} > 0) /set sky_mod=%1 %;/else /set sky_mod=0 %;/endif %;\
  /eval /set sky_time $[mod(time()-8*3600,24*3600)] %;\
  /if (sky_time < 10800) /set sky_mod $[sky_mod - 1] %;/endif %;\
  /echo -aB * Skymark Elves' Forest  ($[ftime("%a %b %d %Y", time() + (sky_mod * 24 * 3600))]) %;\
  /eval /set sky_today $[mod((time()-8*3600)/(24*3600) + 13 + sky_mod, 24)] %;\
  /set sky_r $[mod(sky_today,24)] %;\
  /set sky_g $[mod(sky_today*21,24)] %;\
  /set sky_b $[mod(sky_today*4+12,24)] %;\
  /if (sky_r == sky_g & sky_g == sky_b) \
    /echo -aB * Items Available:  Bough Bracers, Shade Boots, Collar of Bark, Shadowcloak %;\
  /elseif (sky_r == sky_g) \
    /echo -aB * Items Available:  Bough Bracers, Shade Boots %;\
  /elseif (sky_r == sky_b) \
    /echo -aB * Items Available:  Bough Bracers, Collar of Bark %;\
  /else \
    /echo -aB * Items Available:  Nothing! %;\
  /endif %;\
  /if ({#} > 0) /echo -aB * Light Positions:  %sky_r %sky_g %sky_b %;/endif

/SkyPredict
